/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"
#include "tsbrowse.ch"
#include "metrocolor.ch"
#include "mydefines.ch"
#include "Dbinfo.ch"

MEMVAR oBrw1, lPubIndexOpenDbf, lPubIndexOpenPG
FIELD TS, XID
Declare Window Form_Main   //   / you must declare 

STATIC cStaticFileDbf, tStatTimeStamp
////////////////////////////////////////////////////////////
FUNCTION MyOpenDbf()
   LOCAL cFileDbf, aRet := {}, aFile, cAlias, cFile
   LOCAL cFileIndex1, cFileIndex2, cPath := GetStartUpFolder() + "\"

   Form_Main.Button_Dbf.Enabled := .F. //   / lock button

     aFile := GetFile( { {"Dbase file", "*.dbf"}, {" ", "*.*"} }, ; 
                             "  DBF", cPath , .T. ) 
     IF LEN(aFile) > 0
        cFileDbf := aFile[1]
        cStaticFileDbf := cFileDbf //     
        cFile := SUBSTR(cFileDbf,RAT("\",cFileDbf)+1)
        IF LOWER(cFile) == "test.dbf" .OR. LOWER(cFile) == "a_zaivka.dbf"
           USE ( cFileDbf ) Alias DBF2TEST CODEPAGE "RU866" VIA "DBFCDX" NEW EXCLUSIVE
           cFileIndex1 := cPath + SUBSTR(cFile,1,AT(".",cFile)-1) + "1.cdx"
           cFileIndex2 := cPath + SUBSTR(cFile,1,AT(".",cFile)-1) + "2.cdx"
           IF FILE(cFileIndex1)
              ORDLISTADD( cFileIndex1 )
           ENDIF
           IF FILE(cFileIndex1)
              ORDLISTADD( cFileIndex2 )
           ENDIF
           DbSetOrder(1)
           //    c  TS   ( )
           tStatTimeStamp := HB_DATETIME()
           //     
           M->lPubIndexOpenDbf := .T. 
        ELSE
           USE ( cFileDbf ) Alias DBF2TEST CODEPAGE "RU1251" VIA "DBFCDX" NEW EXCLUSIVE
        ENDIF
        cAlias := ALIAS()
        aRet := {cAlias,cFileDbf}
     ENDIF

     Form_Main.Button_Dbf.Enabled := .T. //   / unlock button

RETURN aRet

///////////////////////////////////////////////////////////////////////////////////
FUNCTION MyTableDbf(cAlias,cFileDbf)
   LOCAL cIco  := "Dbf64", cFont := 'Tahoma', nFontSize := 16 
   LOCAL hWnd, nMaxHeight, nMaxWidth
   LOCAL cFormName, cTitle := "Dbf: alias - " + cAlias
   LOCAL nDesktopWidth  := GETDESKTOPREALWIDTH()
   LOCAL nDesktopHeight := GETDESKTOPREALHEIGHT() / 2
   LOCAL cTitlHeaderTable, aBColorTbr  := COLOR_FRH1
   PUBLIC oBrw1

   cFormName  := "Form_Table" + HB_NtoS( _GetId() ) // a unique window name
   DEFINE WINDOW &cFormName         ;
      At 0, 0                       ;
      WIDTH  nDesktopWidth  ; 
      HEIGHT nDesktopHeight ;  
      TITLE cTitle + " (" + cFormName + ")" ;
      ICON cIco                     ;
      WINDOWTYPE STANDARD NOSIZE NOMAXIMIZE ;
      FONT cFont SIZE nFontSize     ;
      BACKCOLOR COLOR_BLUE_BLUE     ;
      ON INIT { || DoMethod( cFormName, "Restore" )  } ;
      ON RELEASE { || OnCloseForm(cAlias) }  
      //NOSIZE NOMAXIMIZE NOMINIMIZE  ;

      hWnd := GetFormHandle(cFormName) 
      nMaxWidth  := This.ClientWidth  // GetClientWidth(hWnd)   
      nMaxHeight := This.ClientHeight // GetClientHeight(hWnd)

      /////////////////////// Building TsBrowse  ////////////////////////////
      SELECT(cAlias)
      goto TOP
      DEFINE TBROWSE oBrw1            ; 
             AT  10 , 10              ; 
             WIDTH  nMaxWidth-10*2    ; 
             HEIGHT nMaxHeight - 10*2 ;
             ON CHANGE  { || ChangeTable() } ;
             ON GOTFOCUS ChangeTable() ;
             BACKCOLOR aBColorTbr      ;
             CELL         

             cTitlHeaderTable := "Datebase - " + LOWER(cFileDbf)
             MyCreateTable(aBColorTbr,cTitlHeaderTable)

      END TBROWSE  
      SetNoHoles( oBrw1 ) //      
      MyCreateTableMenu(cFont, nFontSize)

   END WINDOW

   // DoMethod( cFormName, "Center"   ) // CENTER WINDOW
   DoMethod( cFormName, "Activate" ) // ACTIVATE WINDOW

RETURN NIL

////////////////////////////////////////////////////////////
STATIC FUNCTION  OnCloseForm(cAlias)
   LOCAL cForm := ThisWindow.Name
   DEFAULT cAlias := ALIAS()

   (cAlias)->(DbCloseArea())
   If _IsControlDefined('oBrw1', cForm)
     RELEASE oBrw1 //  -   
   EndIf

   Form_Main.Button_pgSql.Enabled := .F.
   Form_Main.Button_Dbf.Enabled := .T. //   / unlock button

RETURN NIL

////////////////////////////////////////////////////////////
STATIC FUNCTION MyCreateTable(aBColorTbr,cTableName)
    LOCAL cForm := ThisWindow.Name, hWnd := GetFormHandle( cForm )
    LOCAL hFont, nFontSize, aFontGet, aCursorBC, cTypeField, cName
    LOCAL nI, nTxtWidth, cColPict, aMarker[2], cFileDbf, cAlias := Alias() 
    LOCAL nBackForm   := MyRGB( GetProperty(cForm, "Backcolor") )  //    
    LOCAL nBackTable  := MyRGB( aBColorTbr )          //    
    LOCAL nHeadColor1 := MyRGB( COLOR_BLUE_SKYPE  )
    LOCAL nHeadColor2 := MyRGB( {  48,  29, 26  } )  // - 
    LOCAL aHeadColor := YELLOW  //   
    LOCAL aFootColor := YELLOW  //   
    LOCAL nFCount := FCOUNT()   // number of fields in the current work area

    hFont := oBrw1:hFont         //     
    nFontSize := 10
    If hFont != Nil
       aFontGet := GetFontParam(hFont)
       nFontSize := aFontGet[2]  //      
    ENDIF
  
    //       
    nTxtWidth := GetTextWidth( NIL, "0000", hFont ) + 10  // +10  
    ADD COLUMN TO oBrw1 HEADER "" ;
         DATA {|| OrdKeyNo() } ;
         SIZE nTxtWidth PIXELS ;
         NAME NN               ;
         ALIGN DT_CENTER,DT_CENTER,DT_CENTER   // cells, header, footer

     //    
     //     \MiniGUI\SOURCE\TsBrowse\h_tbrowse.prg
     LoadFields( "oBrw1", cForm, .T.)  //   

     //         : "+", "=", "^", "@" 
     SELECT( cAlias )
     FOR nI := 2 TO oBrw1:nColCount() 
         cName := oBrw1:aColumns[nI]:cName 
         cTypeField := FIELDTYPE(FIELDNUM(cName))  //   
         //? nI, cName, cTypeField 
         IF cTypeField == "+" .OR. cTypeField  == "^"
            oBrw1:aColumns[nI]:lEdit := .F. 
            cColPict := REPLICATE("9",8)
            oBrw1:aColumns[nI]:cPicture := cColPict
            nTxtWidth := GetTextWidth( NIL, cColPict, hFont ) 
            oBrw1:SetColSize( nI, nTxtWidth )                  //  
         ELSEIF cTypeField == "=" 
            oBrw1:aColumns[nI]:lEdit := .F. 
            cColPict := REPLICATE("x",22)
            oBrw1:aColumns[nI]:cPicture := cColPict
            nTxtWidth := GetTextWidth( NIL, cColPict, hFont ) 
            oBrw1:SetColSize( nI, nTxtWidth )                  //  
         ELSEIF cTypeField == "@" 
            cColPict := REPLICATE("x",22)
            oBrw1:aColumns[nI]:cPicture := cColPict
            nTxtWidth := GetTextWidth( NIL, cColPict, hFont ) 
            oBrw1:SetColSize( nI, nTxtWidth )                  //  
         ENDIF
     NEXT
	
     //     / Create SUPERHIDER table 
     Add Super Header To oBrw1 From Column 1 To Column 1 ;
         Color CLR_WHITE, { nBackForm, nHeadColor1 } ;
         Title "" 3DLook BITMAP LoadImage("W_Menu") HORZ DT_LEFT

     Add Super Header To oBrw1 From Column 2 To Column nFCount+1 ;
         Color CLR_WHITE, { nBackForm, nHeadColor1 } ;
         Title cTableName 3DLook 

     //     / We hang SuperHeader treatment table
     For nI := 1 To oBrw1:nColCount()
        oBrw1:aColumns[nI]:bHLClicked:={|nRowPix, nCPix, nAt,oBrw| nAt:=nAt, nCPix:=nCPix, if(nRowPix>oBrw:nHeightSuper,,FunSHeader(oBrw))} 
     Next 

     oBrw1:lNoChangeOrd := .T.  //    
     oBrw1:nColOrder := 0       //     

     // -------------- Fixed cursor ,   ---------
     For nI := 1 To oBrw1:nColCount()
        oBrw1:aColumns[nI]:lFixLite := TRUE
     Next

     // --------------------     ------------------------------
     oBrw1:SetColor( { 1}, { { || CLR_BLACK                           } } ) // 1 ,                                  
     oBrw1:SetColor( { 2}, { { || nBackTable                          } } ) // 2 ,                                    
     oBrw1:SetColor( { 3}, { { || MyRGB(aHeadColor)                   } } ) // 3 ,                                     
     oBrw1:SetColor( { 4}, { { || { nHeadColor1, nHeadColor2 }        } } ) // 4 ,   
     oBrw1:SetColor( { 5}, { { || CLR_BLACK                           } } ) // 5 ,  ,                  
     oBrw1:SetColor( { 6}, { { || { 4915199,255}                      } } ) // 6 ,                                            
     oBrw1:SetColor( { 7}, { { || CLR_RED                             } } ) // 7 ,                               
     oBrw1:SetColor( { 8}, { { || CLR_YELLOW                          } } ) // 8 ,                                 
     oBrw1:SetColor( { 9}, { { || MyRGB(aFootColor)                   } } ) // 9 ,                                   
     oBrw1:SetColor( {10}, { { || { nHeadColor1, nHeadColor2 }        } } ) // 10,                                     
     oBrw1:SetColor( {11}, { { || CLR_GRAY                            } } ) // 11,    (selected cell no focused)
     oBrw1:SetColor( {12}, { { || { RGB(255,255,74), RGB(240,240,0) } } } ) // 12,    (selected cell no focused)   
     oBrw1:SetColor( {13}, { { || CLR_WHITE                           } } ) // 13,    
     oBrw1:SetColor( {14}, { { || CLR_RED                             } } ) // 14,      
     oBrw1:SetColor( {15}, { { || CLR_GRAY                            } } ) // 15,     
     oBrw1:SetColor( {16}, { { || {  CLR_WHITE, nHeadColor1 }         } } ) // 16,                                    
     oBrw1:SetColor( {17}, { { || CLR_RED                             } } ) // 17,  
     //  :  /   
     aMarker[ 1 ] := MyRGB( YELLOW )   
     //aMarker[ 1 ] := Rgb( 163, 163, 163 )   //  15%
     aMarker[ 2 ] := Rgb( 127, 127, 127 )   //  25%          
     //     - specialselector header background color
     //oBrw1:nClrSelectorHdBack := CLR_HMAGENTA

     //  :  /   
     aCursorBC := { 4915199,255}
     oBrw1:SetColor( { 6 }, { { |a,b,c,d| a:=d, IF( c:nCell == b, aCursorBC ,;  
                                  { aMarker[1], aMarker[2] })  }   } )            

     cFileDbf := SUBSTR(cStaticFileDbf,RAT("\",cStaticFileDbf)+1)
     IF LOWER(cFileDbf) == "test.dbf"  //    
        // tStatTimeStamp -    c  TS   ( )
        //     -   
        oBrw1:SetColor( { 2 }, { { ||  IIF( (cAlias)->TS > tStatTimeStamp,;
                                             MyRGB( COLOR_LIGHT_2BLUE ) ,;
                                             nBackTable )                  } } )
         cName := oBrw1:aSuperHead[2,3] 
         cName += " - INDEX <fields XID> + INDEX <fields TS>"
         oBrw1:aSuperHead[2,3] := cName  //  
     ENDIF

     //     h_tbrowse.prg
     oBrw1:lNoGrayBar  := .t.  //    
     //oBrw1:nAdjColumn  := 3    //        
     //oBrw1:nHeightCell := 32 + 2*2   //    =  
  
     //oBrw1:nHeightSuper := 60 + 3*2  //   (  )
  
     //oBrw1:nHeightHead := 30 + 2*2   //    =  
     oBrw1:lNoHScroll  := .T.  //   
  
     oBrw1:lFooting := .T.     //  
     oBrw1:lDrawFooters := .T. //   
     oBrw1:nHeightFoot  := oBrw1:nHeightHead  //   
     oBrw1:DrawFooters()       //   
  
     oBrw1:nFreeze     := 1     //  
     oBrw1:lLockFreeze := .T.   //      
     
     oBrw1:ResetVScroll()      //   

     //    .   
     oBrw1:bChange := { |oBrw| ChangeTable(oBrw) }  

     IF oBrw1:nLen == 0  // debugging to look for errors 
        MsgDebug("Stop ! Selection condition TBROWSE == 0 !","DbSetFilter=",DBFILTER())
     ENDIF

     // ----------    / reserve for future ----------------
     //oBrw1:bKeyDown := { | nKey | MyKeyAction1(nKey,oBrw1, ThisWindow.Name, 0), lOk := nKey != VK_ESCAPE }
     //oBrw1:bLDblClick:= { || MyAction1(oBrw1, ThisWindow.Name, 0) } //      

     //   
     // oBrw1:nLen -  -   
     oBrw1:aColumns[1]:cFooting := { || ALLTRIM(Transform( oBrw1:nLen, "999 999" ))  }
  
     oBrw1:Refresh(.T.)
     
     oBrw1:nCell := 2       //   
  
RETURN NIL

////////////////////////////////////////////////////////////
STATIC FUNCTION MyCreateTableMenu(cFont, nFontSize)
    LOCAL cForm := ThisWindow.Name
    LOCAL cMenuFont, cScreen, aTableFont

    cMenuFont := "Font: " + cFont + "  Size: " + HB_NtoS(nFontSize)
    cScreen := IIF(LargeFonts()," LargeFont() "," ... ") + "(" + HB_NtoS(GetDesktopWidth())+"x"+HB_NtoS(GetDesktopHeight()) + ")"
  
    aTableFont := LoadTbrwFonts(oBrw1) //   

    //     -   TBROWSE
    DEFINE CONTEXT MENU CONTROL oBrw1
        MENUITEM "Form / : "   + ThisWindow.Name  ACTION { || MsgInfo(": " + ThisWindow.Name) }
        MENUITEM "Screen / : " + cScreen          ACTION { || MsgInfo(cScreen)    }
        MENUITEM cMenuFont + " /  :"       ACTION { || TableInfoFont(cMenuFont,aTableFont) }
        SEPARATOR
        MENUITEM "Info: super header table / :  "             ACTION { || TableInfoSuperHeader(oBrw1) }  
        MENUITEM "Info: Dimensions table / :   "                ACTION { || TableInfoSize(oBrw1) }
        MENUITEM "Info: Width of the table columns / :   " ACTION { || TableInfoCell(oBrw1) }  
    END MENU

RETURN NIL

////////////////////////////////////////////////////////////
STATIC FUNCTION ChangeTable()
    LOCAL cForm := oBrw1:cParentWnd 
    //LOCAL nLen, cVal, cLen

    //oBrw1:nAt -   
    //oBrw1:nCell -   
    //oBrw1:nLen -  -   

    //cVal := HB_NToS( (oBrw1:cAlias)->(OrdKeyNo()) ) 
    //nLen := (oBrw1:cAlias)->(OrdKeyCount())  
    //cLen := HB_NToS( nLen )

    //oBrw1:aColumns[1]:cFooting := { || ALLTRIM(Transform( nLen, "999 999" ))  }
    //oBrw1:aColumns[2]:cFooting := { || " Recno: " + cVal + "/" + cLen }
    //oBrw1:DrawFooters()       //   

    TblFocus() 
   
    RETURN Nil

/////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION TblFocus()  
   DoMethod(oBrw1:cParentWnd, oBrw1:cControlName, "SetFocus")
   RETURN NIL

////////////////////////////////////////////////////////////////////////
STATIC FUNCTION FunSHeader()
   LOCAL cForm := oBrw1:cParentWnd

   MyPopupImageMenuDbf(cForm)

   IF _IsWindowDefined( cForm ) //  
      TblFocus()
   ENDIF

Return Nil

////////////////////////////////////////////////////////////////////////////////
FUNCTION MyPopupImageMenuDbf(cForm)
   LOCAL hFont, Font1, Font2, nSelect := -1

   hFont := GetFontHandle( "Font_CM1" ) //  handle  0 
   IF hFont == 0
      DEFINE FONT Font_CM1  FONTNAME "Times New Roman" SIZE 16
   ENDIF
   hFont := GetFontHandle( "Font_CM2" ) //  handle  0 
   IF hFont == 0
       DEFINE FONT Font_CM2  FONTNAME "Comic Sans MS" SIZE 16 BOLD
   ENDIF

   Font1 := GetFontHandle( "Font_CM1" )
   Font2 := GetFontHandle( "Font_CM2" )

   SET MENUSTYLE EXTENDED
   SetMenuBitmapHeight( 28 ) 

   DEFINE CONTEXT MENU OF &cForm
       MENUITEM  "1.  Test.dbf"  ACTION  {|| MyCreateIndex()   }  FONT Font2 IMAGE "W_index32"

     IF _IsWindowActive( "Form_SendDbf" ) //   - Form_sending.prg
       MENUITEM  "2. "     ACTION  {|| DoMethod("Form_SendDbf", "Release") }  FONT Font2 IMAGE "W_timer32"
     ELSE
       MENUITEM  "2. "        ACTION  {|| MyRunDbfTimer()   }  FONT Font2 IMAGE "W_timer32"
     ENDIF

       MENUITEM  "3.-./Sync recording"  ACTION  {|| MySyncRecnoDbf2Postgres() }  FONT Font2 IMAGE "W_rfrsh_one32"
       MENUITEM  "4.   " ACTION  {|| MyAppend()  }  FONT Font2 IMAGE "W_add32"
       SEPARATOR                             
       MENUITEM  "  ()"  ACTION  {|| DbfCloseTable(cForm) }  FONT Font1 IMAGE "W_Close32"
   END MENU

   _ShowContextMenu(cForm, 0, 0, .f. ) //      

   InkeyGui(10)  // menu    

   IF _IsWindowDefined( cForm ) //  
      DEFINE CONTEXT MENU OF &cForm
      END MENU
   EndIf 

   //  
   RELEASE FONT Font_CM1
   RELEASE FONT Font_CM2

   RETURN NIL

///////////////////////////////////////////////////////////////////////////
FUNCTION DbfCloseTable(cForm)
    LOCAL cForm2 := "Form_SendDbf" //  Form_sending.prg

    //IF MyOpenPostgreSQL()  //  PostgreSQL  
    //   MsgStop("    !     PostgreSQL !")
    //ELSE
       IF _IsWindowActive( cForm2 )
          DoMethod(cForm2, "Release")  
       ENDIF

       OnCloseForm()
       DoMethod(cForm, "Release")  
    //ENDIF

    RETURN NIL

///////////////////////////////////////////////////////////////////////////
FUNCTION _ShowContextMenu(ParentFormName, nRow, nCol, lCentered)
   LOCAL xContextMenuParentHandle := 0
   LOCAL aRow := GetCursorPos()
   DEFAULT nRow := 0, nCol := 0, ParentFormName := ""

   If .Not. _IsWindowDefined (ParentFormName)
      xContextMenuParentHandle := _HMG_xContextMenuParentHandle
   else
      xContextMenuParentHandle := GetFormHandle ( ParentFormName )
   Endif
   if xContextMenuParentHandle == 0
      MsgMiniGuiError("Context Menu is not defined. Program terminated")
   endif
   IF lCentered
      //nCol := GetWindowCol(xContextMenuParentHandle) + GetWindowWidth(xContextMenuParentHandle)/2 - 60
      //nRow := GetWindowRow(xContextMenuParentHandle) + GetWindowHeight(xContextMenuParentHandle)/2 - GetTitleHeight() - 5
   ELSEIF nRow == 0 .and. nCol == 0
      nCol := aRow[2]
      nRow := aRow[1]
   ENDIF
   TrackPopupMenu ( _HMG_xContextMenuHandle , nCol , nRow , xContextMenuParentHandle )

RETURN Nil

////////////////////////////////////////////////////////////
FUNCTION MyDbf(cFileDbf)
   LOCAL cMsg, nTime, cFileIndex1, cFileIndex2
   LOCAL cFileDtm, cPath, cFile, cExt

   HB_FNameSplit(cFileDbf, @cPath, @cFile, @cExt)
   cFileDtm := HB_FNameMerge(cPath, cFile, '.dtm')    //    TimeStamp
   cFileIndex1 := cPath + cFile + "1.cdx"
   cFileIndex2 := cPath + cFile + "2.cdx"     

   IF !FILE(cFileDbf)                                                                             

       nTime := SECONDS()

       Form_Main.Button_Dbf.Enabled := .F. //   / lock button

       // Create the window waiting with the flow
       //     
       WaitThreadCreate( 'Create dbf-file ...' )

       // Main loop calculations. 
       //   . 
       MyTestDbf(cFileDbf)

       WaitThreadClose()   //   "" / close the "expectations"

       MyCreateIndex(cFileDbf) //  

       cMsg := "DBF-file (base:"+Alias()+") successfully created for - " + SECTOTIME( SECONDS() - nTime ) 
       //MsgInfo(cMsg)

       Form_Main.Button_Dbf.Enabled := .T. //   / unlock button

   ELSE

      //   tStatTimeStamp   
      tStatTimeStamp := HB_DATETIME()

   ENDIF

   RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION MyTestDbf(cFileDbf)
   LOCAL aDbf := {}, nI, nJ, cS, aDim := {}

   AADD( aDbf , {"KGOODS" ,"N",  5, 0 } )
   AADD( aDbf , {"GOODS"  ,"C", 50, 0 } )
   AADD( aDbf , {"NACISL" ,"N", 14, 2 } )
   AADD( aDbf , {"PRIXOD" ,"N", 14, 2 } )
   AADD( aDbf , {"ITOGO " ,"N", 14, 2 } )
   AADD( aDbf , {"SUMDOG" ,"N",  6, 0 } )
   AADD( aDbf , {"KOLVO"  ,"N",  6, 0 } )
   AADD( aDbf , {"DATE1"  ,"D",  8, 0 } ) 
   AADD( aDbf , {"XID"    ,"+",  8, 0 } ) // 
   AADD( aDbf , {"TS"     ,"=",  8, 0 } ) // RDD-TimeStamp ++
   AADD( aDbf , {"VM"     ,"^",  8, 0 } ) // RDD-  
   AADD( aDbf , {"IM"     ,"@",  8, 0 } ) // TimeStamp,  

   AADD( aDim , {  1,'0701                    ',75589.39, 94770.6, 1,130,2021 } )
   AADD( aDim , {  2,'0701100000            ',68303.56, 19262.2, 4,314,7502 } )
   AADD( aDim , {  3,'070200000    ',       0,       0, 0,  0,   0 } ) 
   AADD( aDim , {  4,'0703  ,      ',10028.99,47531.89, 9,217,5553 } )
   AADD( aDim , {  5,'0703200000                       ', 1087.52, 1288.94, 2,  2,  43 } )
   AADD( aDim , {  6,'0703900000 -            ',56801.77,83944.86, 9,243,4613 } )
   AADD( aDim , {  7,'0704100000      ',72519.14, 90663.4, 6, 93,2240 } )
   AADD( aDim , {  8,'0704200000          ', 5870.00, 8204.66, 6,120,2797 } )
   AADD( aDim , {  9,'0704300000             ', 1560.00,  802.33, 5,100, 277 } )
   AADD( aDim , { 10,'070700                 ',18068.84,21015.44, 6, 24, 413 } )
   AADD( aDim , { 11,'0708                       ',       0,       0, 0,  0,   0 } )
   AADD( aDim , { 12,'0708100000  (Pisum sativum)       ',       0,       0, 0,  4, 168 } )
   AADD( aDim , { 13,'0708200000                       ',    4560,    5040, 0,  1, 111 } )
   AADD( aDim , { 14,'0708900000           ',39065.03, 5227.73, 7,332,8974 } )
   AADD( aDim , { 15,'0709200000                       ',    4288,    4752, 6, 13, 105 } )
   AADD( aDim , { 16,'0709300000  ()      ',    3840, 4372.73, 3,  2,  84 } )
   AADD( aDim , { 17,'0706100000                 ', 1412.84, 1750.58, 4, 12, 301 } )
   AADD( aDim , { 18,'0710400000             ',    7200, 8648.47, 7, 20, 169 } )
   AADD( aDim , { 19,'0801000000             ',    1200, 1341.10, 8, 10, 134 } )
   AADD( aDim , { 20,'0801040000       ',     200,  655.07, 4,  2,  19 } )
         
   DBCreate( cFileDbf, aDbf , "DBFCDX")
   USE ( cFileDbf ) Alias TMP2 CODEPAGE "RU866" VIA "DBFCDX" NEW EXCLUSIVE
   cS := ""
   FOR nJ := 1 TO 50
       FOR nI := 1 TO LEN(aDim)
          APPEND BLANK
          TMP2->KGOODS := aDim[nI,1] + (nJ*10) 
          TMP2->GOODS  := cS + aDim[nI,2]
          TMP2->NACISL := aDim[nI,3] / nJ
          TMP2->PRIXOD := aDim[nI,4] / nJ
          TMP2->ITOGO  := aDim[nI,4] - aDim[nI,3]
          TMP2->SUMDOG := aDim[nI,5] * nJ
          TMP2->KOLVO  := aDim[nI,6] * nJ
          TMP2->DATE1  := DATE() - nJ 
          TMP2->IM     := DATE() - 50*nJ 
       NEXT
       cS := PADR(HB_NtoS(nJ),3,"0") 
       DO EVENTS 
   NEXT
   CLOSE TMP2

   RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION MyCreateIndex(cFileDbf)
   LOCAL cMsg, cText, cFileIndex1, cFileIndex2
   LOCAL cFileDtm, cPath, cFile, cExt, lSay := .F.
   DEFAULT cFileDbf := ""

   IF LEN(cFileDbf) == 0
      cFileDbf := cStaticFileDbf
      lSay := .T. //  
   ENDIF

   HB_FNameSplit(cFileDbf, @cPath, @cFile, @cExt)
   cFileIndex1 := cPath + cFile + "1.cdx"
   cFileIndex2 := cPath + cFile + "2.cdx"     
   cFileDtm := HB_FNameMerge(cPath, cFile, '.dtm')    //    TimeStamp

   IF LOWER(cFile) == "test" //test.dbf

      // Create the window waiting with the flow
      WaitThreadCreate( 'Create 2 index file' )

      USE ( cFileDbf ) Alias TMP2 CODEPAGE "RU866" VIA "DBFCDX" NEW EXCLUSIVE

      INDEX ON XID TAG XID TO ( cFileIndex1 ) ADDITIVE
      INDEX ON TS  TAG TS  TO ( cFileIndex2 ) ADDITIVE
      //ORDLISTADD( cFileIndex1 )
      //ORDLISTADD( cFileIndex2 )
      //OrdCreate( cFileInd, cTagName, cKeyVal, bKeyVal, lUnique )

      OrdSetFocus( "TS" )
      DbGobottom() //    

      HB_memoWrit(cFileDtm, HB_TTOS(FieldGet(FieldNum('TS'))))
      //cDtm  := hb_MemoRead(cFileDtm)
      //    c  TS   ( )
      tStatTimeStamp := FieldGet(FieldNum('TS'))

      //OrdSetFocus( "XID" )
      //DbGoTop() //    

      CLOSE TMP2

      WaitThreadClose()   // close the "expectations"

      IF lSay

         cText := oBrw1:aSuperHead[2,3] 
         cText += " - INDEX <fields XID> + INDEX <fields TS>"
         oBrw1:aSuperHead[2,3] := cText  //  

         cMsg := "    !" + CRLF + CRLF
         cMsg += cFileIndex1 + CRLF
         cMsg += cFileIndex2 + CRLF

         MsgInfo(cMsg)

      ENDIF

      //     
      M->lPubIndexOpenDbf := .T. 

   ELSE
      cMsg := "    -test.dbf !" + CRLF + CRLF
      cMsg += " XID  TS      !" + CRLF
      MsgStop(cMsg)
   ENDIF // LOWER(cFileDbf) == "test.dbf1"

   /*   //   tStatTimeStamp   
      cDtm := hb_MemoRead(cFileDtm)
      IF !FILE(cFileDtm)
        //    c  TS   ( )
         tStatTimeStamp := hb_STOT(cDtm)
      ELSE
         USE ( cFileDbf ) Alias DBF2TEST CODEPAGE "RU1251" VIA "DBFCDX" NEW EXCLUSIVE
         tStatTimeStamp := FieldGet(FieldNum('TS'))
         CLOSE DBF2TEST
      ENDIF
      //  tStatTimeStamp := HB_DATETIME()
      // cDtm := HB_TSTOSTR (HB_DATETIME())
   */
   
   RETURN NIL

//////////////////////////////////////////////////////////////////////
FUNCTION MySyncRecnoDbf2Postgres()
   LOCAL cMsg, cFileDbf, cStr, nSec, cTime, aChangeRec, cList
   LOCAL nRecno, nOrdIndex, nI

   cStr := TIME()
   cFileDbf := SUBSTR(cStaticFileDbf,RAT("\",cStaticFileDbf)+1)
   IF LOWER(cFileDbf) == "test.dbf"

      IF !MyOpenPostgreSQL()  
         cMsg := " PostgreSQL   !"  
         LogTimer1Dbf(cStr + "-" + cMsg)  //   - Form_sending.prg
         MsgStop(cMsg + CRLF)
         RETURN NIL
      ENDIF

      //     
      IF ! M->lPubIndexOpenDbf 
         cMsg := "    -test.dbf !"  
         LogTimer1Dbf(cStr + "-" + cMsg)  //   - Form_sending.prg
         MsgStop(cMsg + CRLF)
         RETURN NIL
      ENDIF

      //     
      IF ! M->lPubIndexOpenPG 
         cMsg := "    PostgreSQL !"
         LogTimer1Dbf(cStr + "-" + cMsg)  //   - Form_sending.prg
         MsgStop(cMsg + CRLF)
         RETURN NIL
      ENDIF
      
      nSec := SECONDS()

      nRecno := (oBrw1:cAlias)->(RecNo())

      nOrdIndex := OrdCount()
      IF nOrdIndex == 0
         cList := "  " ; cTime := "!"
      ELSE
         aChangeRec := ListChangeRec()
         cList := "" ; cTime := ""
         IF LEN(aChangeRec) > 0 
            cList += "XID="
            FOR nI := 1 TO LEN(aChangeRec)
   //             SELECT DBF2TEST 
   //             DBSETORDER(0)
   //             GOTO(aChangeRec[nI])
   //             //       PostgreSQL
   //             //        Form_PostgreSQL.prg
   //             //  MyWriteRecnoDbf2PostgreSQL( ALIAS(), ....)     
                cList += HB_NtoS( (ALIAS())->XID ) + ", "
            NEXT
            MyWriteRecnoDbf2PostgreSQL( aChangeRec, ALIAS())

            DBSETORDER(1)
            cTime := HB_NtoS( SECONDS() - nSec )+" sec." 
         ENDIF
      ENDIF

      cStr += " - " + cTime + " " + cList
      LogTimer1Dbf(cStr)  //   - Form_sending.prg

      //    c  TS   ( )
      tStatTimeStamp := HB_DATETIME()

      oBrw1:GoToRec( nRecno )   
      oBrw1:Refresh(.T.)  //  

   ELSE
      cMsg := "    -test.dbf !" + CRLF + CRLF
      cMsg += " XID  TS      !" + CRLF
      MsgStop(cMsg)
   ENDIF // LOWER(cFileDbf) == "test.dbf1"
   
   RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION MyRunDbfTimer()
   LOCAL aRet

   aRet := Form_SendDbf2PG()  // -  
   IF LEN(aRet) > 0
      Show_SendDbf2PG()  //   -
   ENDIF 

   RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION ListChangeRec()
   LOCAL aRec := {}

   // tStatTimeStamp    c  TS  
   SELECT DBF2TEST 
   OrdSetFocus( "TS" )
   dbSeek(tStatTimeStamp, .T. )   // Set softseek on
   DO WHILE !EOF() 
      IF DBF2TEST->TS >= tStatTimeStamp 
          AADD( aRec, RECNO() )
      ENDIF
      dbSkip(1)
   ENDDO
   OrdSetFocus( "XID" )

   RETURN aRec

////////////////////////////////////////////////////////////
FUNCTION MyAppend()
   LOCAL nLen, nRecno

   (oBrw1:cAlias)->(DbAppend())
   nRecno := (oBrw1:cAlias)->(RecNo())
   
   //nLen := (oBrw1:cAlias)->(OrdKeyCount())  
   nLen := oBrw1:nLen //  -   
 
   oBrw1:aColumns[1]:cFooting := { || ALLTRIM(Transform( nLen, "999 999" ))  }
   oBrw1:DrawFooters()       //   

   oBrw1:GoToRec( nRecno )   
   oBrw1:Refresh(.T.)  //  

   TblFocus() 

   RETURN NIL

////////////////////////////////////////////////////////////
