/*
 * MINIGUI - Harbour Win32 GUI library
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"
#include "metrocolor.ch"
#include "mydefines.ch"

/////////////////////////////////////////////////////////////////////////
FUNCTION Form_SQLconfig()
   LOCAL cTitle := "New Server Registration"
   LOCAL cIco  := "PgSql64", cFontName := 'Tahoma', nFontSize := 16
   LOCAL aBackColor := { 0, 145, 208 } 
   LOCAL aButtColor := WHITE, aButtColor2 := BLACK
   LOCAL aBackColorPage := { COLOR_BLUE_TWIT, COLOR_LIGHT_BLUE }
   LOCAL aPageName      := { "General"      , "Connection"     }
   LOCAL nFBSize2 := IIF(LargeFonts(),nFontSize-2,nFontSize)
   LOCAL hWnd, nMaxHeight, nMaxWidth, aRet := {}
   LOCAL nHButt, nWButt, nRowButt, nColButt
   LOCAL nFBSize := IIF(LargeFonts(),8,10)

   PUBLIC nPub2pgSqlGroup, nPub2pgSqlName, nPub2pgSqlRem, aPub2pgSqlIp, nPub2pgSqlPort  
   PUBLIC cPub2pgSqlDb, cPub2pgSqlUser, cPub2pgSqlPass, cPub2pgSqlShema 

   LoadConfig() //    -

   DEFINE WINDOW Form_Cnf             ;
        At 0, 0                       ;
        WIDTH 600 HEIGHT 600          ;
        TITLE cTitle                  ;
        ICON cIco                     ;
        MODAL                         ;
        NOSIZE                        ;
        FONT cFontName SIZE nFontSize - 2 ;
        BACKCOLOR aBackColor          ;
        ON INIT { || SetProperty("Form_Cnf", "Topmost", .T.), MyInitConfig() }

        hWnd := GetFormHandle('Form_Cnf') 
        nMaxWidth  := This.ClientWidth   
        nMaxHeight := This.ClientHeight

        @ 5,nMaxWidth-70 IMAGE Image_0 PICTURE 'LOGO' WIDTH 64 HEIGHT 64 STRETCH ;
          TRANSPARENT BACKGROUNDCOLOR aBackColor

        @ 10, 10 LABEL Label_0 VALUE "PostgreSQL" BOLD SIZE nFontSize + 6;
          WIDTH nMaxWidth-10-64-10 HEIGHT (nFontSize+6)*2 ;
          FONTCOLOR WHITE TRANSPARENT RIGHTALIGN

        DEFINE TAB Tab_1 AT 40,10 WIDTH nMaxWidth-20 HEIGHT 470 VALUE 1 ;
           FONT 'Arial' SIZE IIF(LargeFonts(),nFontSize,nFontSize+2) BOLD ;
           ON CHANGE NIL BACKCOLOR aBackColor HOTTRACK

           PAGE PADC(aPageName[1],13) 
                MenuCnf_Page1(aBackColorPage[1],cFontName,nFontSize)  
           END PAGE 

           PAGE PADC(aPageName[2],13)  
                MenuCnf_Page4(aBackColorPage[2],cFontName,nFontSize)  
           END PAGE 

       END TAB 

       ////////////////////// button ///////////////////////////////////
       nHButt := 50     // button height
       nWButt := 150    // button width
       nRowButt := nMaxHeight - nHButt - 10

       nColButt := nMaxWidth - nWButt*3 - 10*3 - nWButt/2
       @ nRowButt, nColButt BUTTONEX Button_Connect  ;
          WIDTH nWButt+nWButt/2 HEIGHT nHButt   ;
          CAPTION 'Connect Server'       ;
          ICON "iConnect32x1"            ;
          FONTCOLOR aButtColor           ;
          BACKCOLOR COLOR_GREEN_METRO    ;
          SIZE nFBSize2                  ;
          NOXPSTYLE HANDCURSOR NOTABSTOP ;
          ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iConnect32x2") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor2 ) ) ;
          ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iConnect32x1") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor ) ) ;
          ACTION { || aRet := SaveConfig(), Form_Cnf.Release() }   
                                 
       nColButt := nMaxWidth - nWButt*2 - 10*2
       @ nRowButt, nColButt BUTTONEX Button_Save  ;
          WIDTH nWButt HEIGHT nHButt     ;
          CAPTION 'Save'                 ;
          ICON "iSave32x1"               ;
          FONTCOLOR aButtColor           ;
          BACKCOLOR COLOR_LIGHT_ORANGE   ;
          SIZE nFBSize2                  ;
          NOXPSTYLE HANDCURSOR NOTABSTOP ;
          ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iSave32x2") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor2 ) ) ;
          ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iSave32x1") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor ) ) ;
          ACTION { || SaveConfig() }   

       nColButt := nMaxWidth - nWButt - 10
       @ nRowButt, nColButt BUTTONEX Button_Exit ;
          WIDTH nWButt HEIGHT nHButt     ;
          ICON "iCancel32x1"             ;
          CAPTION 'Cancel'               ;
          FONTCOLOR aButtColor           ;
          BACKCOLOR COLOR_RED_METRO      ;
          SIZE nFBSize2                  ;
          NOXPSTYLE HANDCURSOR NOTABSTOP ;
          ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iCancel32x2") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor2 ) ) ;
          ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iCancel32x1") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor ) ) ;
          ACTION { || aRet := {}, Form_Cnf.Release() } 

       ON KEY ESCAPE ACTION ThisWindow.Release

   END WINDOW

   CENTER WINDOW Form_Cnf
   ACTIVATE WINDOW Form_Cnf

RETURN aRet
////////////////////////////////////////////////////////
FUNCTION MyInitConfig()
   LOCAL nTabWidth, nTabHeight, nRowTab, nWLbl
   LOCAL hWnd := GetFormHandle( _HMG_ThisFormName )
   LOCAL nMaxHeight, nMaxWidth, nRow, nCol, nHButt2Win, nTabRow

   nMaxWidth  := This.ClientWidth  // GetClientWidth(hWnd)   
   nMaxHeight := This.ClientHeight // GetClientHeight(hWnd)

   nTabRow  := Form_Cnf.Tab_1.Row

   //        
   nHButt2Win := nMaxHeight - Form_Cnf.Button_Exit.Row - Form_Cnf.Button_Exit.Height

   nRow := nMaxHeight - nHButt2Win*2 - nTabRow - Form_Cnf.Button_Exit.Height
   Form_Cnf.Tab_1.Height := nRow

   nTabWidth  := GetWindowWidth(GetControlHandle('Tab_1', ThisWindow.Name )) - 2*2
   nTabHeight := GetWindowHeight(GetControlHandle('Tab_1', ThisWindow.Name)) - 2 
   nRowTab := Form_Cnf.Label_BackP1.Row - 2

   Form_Cnf.Label_BackP1.Row   := 38 //40
   Form_Cnf.Label_BackP1.Width := nTabWidth
   Form_Cnf.Label_BackP1.Height := nTabHeight  - nRowTab

   nWLbl := Form_Cnf.Label_PGsg.Col + Form_Cnf.Label_PGsg.Width + 10
   Form_Cnf.TextBox_PGsg.Width   := nTabWidth - nWLbl - 30 
   Form_Cnf.TextBox_PGName.Width := nTabWidth - nWLbl - 30
   Form_Cnf.Edit_PGRem.Width     := nTabWidth - nWLbl - 30 

   Form_Cnf.Label_BackP4.Row   := 38 //40
   Form_Cnf.Label_BackP4.Width := nTabWidth
   Form_Cnf.Label_BackP4.Height := nTabHeight  - nRowTab

   nWLbl := Form_Cnf.Label_PGIp.Col + Form_Cnf.Label_PGIp.Width + 10
   Form_Cnf.IPADDRESS_PG.Width  := nTabWidth - nWLbl - 30
   Form_Cnf.TextBox_PGp.Width   := nTabWidth - nWLbl - 30
   Form_Cnf.TextBox_PGdb.Width  := nTabWidth - nWLbl - 30
   Form_Cnf.TextBox_PGUser.Width:= nTabWidth - nWLbl - 30 
   Form_Cnf.Text_PGPass.Width   := nTabWidth - nWLbl - 30 
   Form_Cnf.Text_PGPass2.Width  := nTabWidth - nWLbl - 30 
   Form_Cnf.TextBox_PGRole.Width:= nTabWidth - nWLbl - 30 
   Form_Cnf.ComboEx_SSL.Width   := nTabWidth - nWLbl - 30 

   nCol := Form_Cnf.Text_PGPass.Col + Form_Cnf.Text_PGPass.Width + 10
   Form_Cnf.Check_PGPass.Col    := nCol

RETURN NIL

////////////////////////////////////////////////////////
FUNCTION MenuCnf_Page1(aBackColorPage,cFontName,nFontSize)  
   LOCAL hWnd := GetFormHandle( _HMG_ThisFormName )
   LOCAL nMaxHeight, nMaxWidth, nRow, nRow2, nCol, nCol2
   LOCAL nD, nWLbl, nWGet
   DEFAULT cFontName := ""

   nMaxWidth  := This.ClientWidth  // GetClientWidth(hWnd)   
   nMaxHeight := This.ClientHeight // GetClientHeight(hWnd)

   nRow := 40 ; nCol := 0
   nRow2 := nRow + 20
   nCol := 30 ; nWLbl := 120 
   nCol2 := nCol + nWLbl + 10 
   nWGet := 400 ; nD := 15

   @ nRow, 2 LABEL Label_BackP1 WIDTH nMaxWidth-30 HEIGHT 450 ;
     VALUE "" BACKCOLOR aBackColorPage

   @ nRow2, nCol LABEL Label_PGsg WIDTH nWLbl HEIGHT nFontSize*2 ;
     VALUE "Server Group" TRANSPARENT FONTCOLOR BLACK                

   @ nRow2, nCol2 TEXTBOX TextBox_PGsg VALUE M->nPub2pgSqlGroup ;
      WIDTH nWGet HEIGHT nFontSize*2 BACKCOLOR {255,255,255} BOLD ;
      ON CHANGE {|| M->nPub2pgSqlGroup := Form_Cnf.TextBox_PGsg.Value }

   @ nRow2 + 50, nCol LABEL Label_PGName WIDTH nWLbl HEIGHT nFontSize*2 ;
      VALUE "Name" FONTCOLOR BLACK BACKCOLOR aBackColorPage

   @ nRow2 + 50, nCol2 TEXTBOX TextBox_PGName VALUE M->nPub2pgSqlName ;
      WIDTH nWGet HEIGHT nFontSize*2 BACKCOLOR {255,255,255} BOLD ;
      ON CHANGE {|| M->nPub2pgSqlName := Form_Cnf.TextBox_PGName.Value }

   @ nRow2 + 50*2, nCol LABEL Label_PGRem WIDTH nWLbl HEIGHT nFontSize*2 ;
      VALUE "Comments" FONTCOLOR BLACK BACKCOLOR aBackColorPage

   @ nRow2 + 50*2, nCol2 EDITBOX Edit_PGRem ;
      WIDTH nWGet HEIGHT 250                ;
      VALUE M->nPub2pgSqlRem                ;
      BACKCOLOR WHITE FONTCOLOR BLACK       ;
      MAXLENGTH 400 NOHSCROLL NOVSCROLL     ; 
      ON CHANGE {|| M->nPub2pgSqlRem := Form_Cnf.Edit_PGRem.Value }

   RETURN Nil

////////////////////////////////////////////////////////
FUNCTION MenuCnf_Page4(aBackColorPage,cFontName,nFontSize)  
   LOCAL hWnd := GetFormHandle( _HMG_ThisFormName )
   LOCAL nMaxHeight, nMaxWidth, nRow, nRow2, nCol, nCol2, aSsl
   LOCAL nD, nWLbl, nWGet, nTemp, lPassword := .F.
   DEFAULT cFontName := ""
 
   nMaxWidth  := This.ClientWidth  // GetClientWidth(hWnd)   
   nMaxHeight := This.ClientHeight // GetClientHeight(hWnd)

   nRow := 40 
   nRow2 := nRow + 20
   nCol := 30 ; nWLbl := 120 
   nCol2 := nCol + nWLbl + 10 
   nWGet := 400 ; nD := 15

   @ nRow,2 LABEL Label_BackP4 WIDTH nMaxWidth-30 HEIGHT 450 ;
     VALUE "" BACKCOLOR aBackColorPage

   @ nRow2, nCol LABEL Label_PGIp WIDTH nWLbl HEIGHT nFontSize*2 ;
     VALUE "Host Address" TRANSPARENT FONTCOLOR BLACK                

   @ nRow2, nCol2 IPADDRESS IPADDRESS_PG WIDTH nWGet HEIGHT nFontSize*2 ;
     VALUE M->aPub2pgSqlIp BOLD                                       ;
     ON CHANGE {|| M->aPub2pgSqlIp := Form_Cnf.IPADDRESS_PG.Value }

   @ nRow2 + 50, nCol LABEL Label_PortPG WIDTH nWLbl HEIGHT nFontSize*2 ;
      VALUE "Port" FONTCOLOR BLACK BACKCOLOR aBackColorPage

   @ nRow2 + 50, nCol2 TEXTBOX TextBox_PGp VALUE M->nPub2pgSqlPort ;
      WIDTH nWGet HEIGHT nFontSize*2 BACKCOLOR {255,255,255} NUMERIC BOLD ;
      ON CHANGE {|| M->nPub2pgSqlPort := Form_Cnf.TextBox_PGp.Value }

   @ nRow2 + 50*2, nCol LABEL Label_PGdb WIDTH nWLbl HEIGHT nFontSize*2*2 ;
      VALUE "Maintenance Database" FONTCOLOR BLACK BACKCOLOR aBackColorPage

   @ nRow2 + 50*2, nCol2 TEXTBOX TextBox_PGdb VALUE M->cPub2pgSqlDb ;
      WIDTH nWGet HEIGHT nFontSize*2 BACKCOLOR {255,255,255} BOLD ;
      ON CHANGE {|| M->cPub2pgSqlDb := Form_Cnf.TextBox_PGdb.Value }

   @ nRow2 + 50*3+nD, nCol LABEL Label_PGUser WIDTH nWLbl HEIGHT nFontSize*2 ;
      VALUE "User Name" FONTCOLOR BLACK BACKCOLOR aBackColorPage

   @ nRow2 + 50*3+nD, nCol2 TEXTBOX TextBox_PGUser VALUE M->cPub2pgSqlUser ;
      WIDTH nWGet HEIGHT nFontSize*2 BACKCOLOR {255,255,255} BOLD ;
      ON CHANGE {|| M->cPub2pgSqlUser := Form_Cnf.TextBox_PGUser.Value }

   @ nRow2 + 50*4+nD, nCol LABEL Label_PGPswr WIDTH nWLbl HEIGHT nFontSize*2 ;
      VALUE "Password" FONTCOLOR BLACK BACKCOLOR aBackColorPage

   @ nRow2 + 50*4+nD, nCol2 TEXTBOX Text_PGPass      ;
      WIDTH nWGet HEIGHT nFontSize*2                 ;
      VALUE M->cPub2pgSqlPass PASSWORD               ;
      ON LOSTFOCUS {|| M->cPub2pgSqlPass := AllTrim(Form_Cnf.Text_PGPass.Value)  }

   @ nRow2 + 50*4+nD, nCol2 TEXTBOX Text_PGPass2     ;
      WIDTH nWGet HEIGHT nFontSize*2                 ;
      VALUE M->cPub2pgSqlPass INVISIBLE              ;
      ON LOSTFOCUS {|| M->cPub2pgSqlPass := AllTrim(Form_Cnf.Text_PGPass2.Value)  }

   @ nRow2 + 50*4+nD, nCol2 + nWGet CHECKBOX Check_PGPass CAPTION '' VALUE lPassword ;
     WIDTH 20 HEIGHT nFontSize*2              ;
     FONTCOLOR WHITE BACKCOLOR aBackColorPage ;
     TOOLTIP "Show password" BOLD             ;
     ON CHANGE {|| lPassword := Form_Cnf.Check_PGPass.Value, ;
                   iif( lPassword, ( DoMethod(ThisWindow.Name,"Text_PGPass","Hide"),;
                   Form_Cnf.Text_PGPass2.Value := M->cPub2pgSqlPass,;
                   DoMethod(ThisWindow.Name,"Text_PGPass2","Show") ),;
                   ( DoMethod(ThisWindow.Name,"Text_PGPass2","Hide"),;
                   Form_Cnf.Text_PGPass.Value := GetProperty(ThisWindow.Name,"Text_PGPass2","Value"),;
                   DoMethod(ThisWindow.Name,"Text_PGPass","Show") ) )  }

   @ nRow2 + 50*5+nD, nCol LABEL Label_PGRole WIDTH nWLbl HEIGHT nFontSize*2 ;
      VALUE "Schema" FONTCOLOR BLACK BACKCOLOR aBackColorPage

   @ nRow2 + 50*5+nD, nCol2 TEXTBOX TextBox_PGRole VALUE M->cPub2pgSqlShema  ;
      WIDTH nWGet HEIGHT nFontSize*2 BACKCOLOR {255,255,255} BOLD         ;
      ON CHANGE {|| M->cPub2pgSqlShema := Form_Cnf.TextBox_PGRole.Value }

   @ nRow2 + 50*6+nD, nCol LABEL Label_PGssl WIDTH nWLbl HEIGHT nFontSize*2  ;
      VALUE "SSL Mode" FONTCOLOR BLACK BACKCOLOR aBackColorPage

   nTemp := 4
   aSsl := { "Allow", "Prefer", "Require", "Disable", "Verify-CA", "Verify-Full" }
   @ nRow2 + 50*6+nD, nCol2 COMBOBOX ComboEx_SSL ;
     WIDTH nWGet HEIGHT 200                      ;
     ITEMS aSsl VALUE nTemp                      ;
     BOLD BACKCOLOR SILVER                       ;
     ON CHANGE { || nTemp := Form_Cnf.ComboEx_SSL.Value }

   Form_Cnf.ComboEx_SSL.Enabled := .F.

   RETURN Nil

////////////////////////////////////////////////////////
STATIC FUNCTION SaveConfig()
   LOCAL aDim[9], cMsg

   cMsg := AtRepl( CRLF, M->nPub2pgSqlRem, "|" )

   aDim[1] := M->nPub2pgSqlGroup 
   aDim[2] := M->nPub2pgSqlName  
   aDim[3] := cMsg //M->nPub2pgSqlRem   
   aDim[4] := M->aPub2pgSqlIp    
   aDim[5] := M->nPub2pgSqlPort  
   aDim[6] := M->cPub2pgSqlDb    
   aDim[7] := M->cPub2pgSqlUser  
   aDim[8] := M->cPub2pgSqlPass  
   aDim[9] := M->cPub2pgSqlShema 

   IniSetPG("Connect",'',"Group 1",aDim)

   RETURN aDim

////////////////////////////////////////////////////////
STATIC FUNCTION LoadConfig()
   LOCAL aDim, cMsg

   aDim := IniGetPG("Connect",'',"Group 1")

   cMsg := AtRepl( "|", aDim[3], CRLF )

   M->nPub2pgSqlGroup := aDim[1]
   M->nPub2pgSqlName  := aDim[2]
   M->nPub2pgSqlRem   := cMsg
   M->aPub2pgSqlIp    := aDim[4]
   M->nPub2pgSqlPort  := aDim[5]
   M->cPub2pgSqlDb    := aDim[6]
   M->cPub2pgSqlUser  := aDim[7]
   M->cPub2pgSqlPass  := aDim[8]
   M->cPub2pgSqlShema := aDim[9]

   RETURN NIL
