/*
 * MINIGUI - Harbour Win32 GUI library
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"
#include "metrocolor.ch"

/*
PROCEDURE MAIN
   LOCAL aDim, aTblStruct

   SET LANGUAGE TO RUSSIAN  
   SET CODEPAGE TO RUSSIAN  
   SET NAVIGATION EXTENDED
   SET MULTIPLE OFF WARNING

   SET EPOCH TO ( Year(Date()) - 50 )
   SET DATE FORMAT "DD.MM.YY"
   SET TOOLTIP BALLOON ON
   SET Date TO GERMAN

aTblStruct := { ;
{"id", "N", 9, 0}     , ;	
{"kgoods", "N", 5, 0}, ;	
{"goods", "C", 50, 0}, ;	
{"nacisl", "N", 15, 2}, ;	
{"prixod", "N", 15, 2}, ;	
{"itogo", "N", 15, 2}, ;	
{"sumdog", "N", 6, 0}, ;	
{"kolvo", "N", 6, 0}, ;	
{"date1", "D", 8, 0}, ;	
{"id2", "N", 9, 0}, ;	
{"ts", "C", 20, 0}, ;	
{"vm", "N", 9, 0}, ;	
{"im", "C", 20, 0} }	

   DEFINE WINDOW Form_Main AT 0,0     ;
       WIDTH 700 HEIGHT 500           ;
       MAIN                           ;
       TITLE "Test config"            ; 
       ICON "1MAIN_ICO"               ;
       BACKCOLOR COLOR_BLUE_TWIT      ;
       NOMAXIMIZE NOSIZE NOSYSMENU    ;
       ON INIT {|| IniSetIsFilePG("Connect",'',"Group 1"), ;
                   Form_Main.Hide, aDim := Form_SQLindex(aTblStruct,"Test_10"), MsgDebug(aDim), ;
                   ThisWindow.Release }  ;

   END WINDOW

   CENTER WINDOW Form_Main
   ACTIVATE WINDOW Form_Main

RETURN
*/
/////////////////////////////////////////////////////////////////////////
FUNCTION Form_SQLindex(aTblStruct,cNameTable)
   LOCAL cTitle := "Create a primary key PostgreSQL table"
   LOCAL cIco  := "PgSql64", cFontName := 'Tahoma', nFontSize := 16
   LOCAL aBackColor := { 0, 145, 208 } 
   LOCAL aButtColor := WHITE, aButtColor2 := BLACK
   LOCAL nFBSize2 := IIF(LargeFonts(),nFontSize-2,nFontSize)
   LOCAL nMaxHeight, nMaxWidth, aRet := {}, aTable := {}
   LOCAL nI, nHButt, nWButt, nRowButt, nColButt, nRow2, cIndex := ""
   LOCAL nFBSize := IIF(LargeFonts(),8,10)

   FOR nI := 1 TO LEN(aTblStruct)
       AADD( aTable, { STR(nI,4), aTblStruct[nI,1], aTblStruct[nI,2], STR(aTblStruct[nI,3],4), STR(aTblStruct[nI,4],3) } )
   NEXT

   DEFINE WINDOW Form_Indx            ;
        At 0, 0                       ;
        WIDTH 600 HEIGHT 600          ;
        TITLE cTitle                  ;
        ICON cIco                     ;
        MODAL                         ;
        NOSIZE                        ;
        FONT cFontName SIZE nFontSize - 2 ;
        BACKCOLOR aBackColor          ;
        ON INIT { || Form_Indx.Grid_2.Setfocus }

        nMaxWidth  := This.ClientWidth   
        nMaxHeight := This.ClientHeight

        ////////////////////// button ///////////////////////////////////
        nHButt := 50     // button height
        nWButt := 150    // button width
        nRowButt := nMaxHeight - nHButt - 10

        @ 5,nMaxWidth-70 IMAGE Image_0 PICTURE 'LOGO' WIDTH 64 HEIGHT 64 STRETCH ;
          TRANSPARENT BACKGROUNDCOLOR aBackColor

        @ 10, 10 LABEL Label_0 VALUE "Primary key PostgreSQL table" BOLD SIZE nFontSize + 6;
          WIDTH nMaxWidth-10-64-10 HEIGHT (nFontSize+6)*2 ;
          FONTCOLOR WHITE TRANSPARENT RIGHTALIGN

    	@ 64,10 FRAME Frame_1 CAPTION " Table: " + cNameTable + " " ;
          FONT 'Arial' SIZE IIF(LargeFonts(),nFontSize,nFontSize+2) BOLD ;
          WIDTH nMaxWidth-10*2 HEIGHT nRowButt - 74 TRANSPARENT

        DEFINE GRID Grid_2
            ROW    94
            COL    20
            WIDTH  nMaxWidth-20*2
            HEIGHT nRowButt - 124 - IIF(LargeFonts(),nFontSize*3,nFontSize*2)
            ITEMS aTable
            VALUE 0
            WIDTHS  { 60, 260, 90, 60, 60 }
            HEADERS {'', ' Name', 'Type', ' Len', ' Dec'}
            NOLINES .T.
            TABSTOP .F.
            BACKCOLOR COLOR_BLUE_TWIT         
            ON DBLCLICK Grid_Choice(cNameTable)
        END GRID

        nRow2 := Form_Indx.Frame_1.Row + Form_Indx.Frame_1.Height - 10 - IIF(LargeFonts(),nFontSize*3,nFontSize*2)
        @ nRow2, 20 TEXTBOX TextBox_1 VALUE '' ;
           WIDTH nMaxWidth-20*2 HEIGHT nFontSize*2 BACKCOLOR {255,255,255} BOLD ;
           ON CHANGE {|| cIndex := Form_Indx.TextBox_1.Value }

       nColButt := nMaxWidth - nWButt*2 - 10*2 - nWButt/2
       @ nRowButt, nColButt BUTTONEX Button_Save  ;
          WIDTH nWButt+nWButt/2 HEIGHT nHButt     ;
          CAPTION 'Create index'         ;
          ICON "iSave32x1"               ;
          FONTCOLOR aButtColor           ;
          BACKCOLOR COLOR_GREEN_METRO    ;
          SIZE nFBSize2                  ;
          NOXPSTYLE HANDCURSOR NOTABSTOP ;
          ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iSave32x2") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor2 ) ) ;
          ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iSave32x1") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor ) ) ;
          ACTION { || IF( LEN(cIndex) == 0, MsgStop("     !"), aRet := { cIndex } ),;
                      IF( LEN(cIndex) == 0, NIL,    Form_Indx.Release() ) }   

       nColButt := nMaxWidth - nWButt - 10
       @ nRowButt, nColButt BUTTONEX Button_Exit ;
          WIDTH nWButt HEIGHT nHButt     ;
          ICON "iCancel32x1"             ;
          CAPTION 'Cancel'               ;
          FONTCOLOR aButtColor           ;
          BACKCOLOR COLOR_RED_METRO      ;
          SIZE nFBSize2                  ;
          NOXPSTYLE HANDCURSOR NOTABSTOP ;
          ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iCancel32x2") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor2 ) ) ;
          ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iCancel32x1") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor ) ) ;
          ACTION { || aRet := {}, Form_Indx.Release() } 

       ON KEY ESCAPE ACTION ThisWindow.Release

   END WINDOW

   CENTER WINDOW Form_Indx
   ACTIVATE WINDOW Form_Indx

RETURN aRet

////////////////////////////////////////////////////////
FUNCTION Grid_Choice(cNameTable)
   Local xMenuNum := Form_Indx.Grid_2.Value
   Local cMenuName, cType, cIndex, cText := "" 

   IF VALTYPE(xMenuNum) == "N"
      cMenuName := GetProperty( "Form_Indx", "Grid_2", "Cell", xMenuNum, 2 )
      cType := GetProperty( "Form_Indx", "Grid_2", "Cell", xMenuNum, 3 )
      cText += "Menu selection = " + STR(xMenuNum,2) + CRLF + CRLF
   ELSE  // celled grid
      cMenuName := GetProperty( "Form_Indx", "Grid_2", "Cell", xMenuNum[1], 2 )
      cType    := GetProperty( "Form_Indx", "Grid_2", "Cell", xMenuNum[1], 3 )
      cText += "Menu selection = {" + STR(xMenuNum[1],2)+","+STR(xMenuNum[2],2)+" }" + CRLF + CRLF
   ENDIF
   cText += "Menu  (2): ["+ cMenuName + "]" + CRLF + CRLF
   cText += "cType (3): ["+ cType + "]"
   //MsgInfo( cText )
   cIndex := "ALTER TABLE "+cNameTable+" ADD PRIMARY KEY ("+cMenuName+")" 
   Form_Indx.TextBox_1.Value := cIndex
   Form_Indx.TextBox_1.Setfocus

   RETURN NIL

