/*                                                                                  	
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2016 Sidorov Aleksandr <aksidorov@mail.ru>
*/

#include "minigui.ch"
#include "tsbrowse.ch"
#include "metrocolor.ch"
#include "mydefines.ch"
#include "postgres.ch"

MEMVAR oBrw2, oServer //, cQuery, oQuery //, PGoBrw
  
STATIC cStaticPathTable, cStaticNamePgTable, cStaticConnInfo, tStatTimeStamp
STATIC cStaticFormTable     //, oServer, cQuery, oQuery
///////////////////////////////////////////////////////////////////////////////////
FUNCTION MyPgSql( cAlias, cFileDbf )
   LOCAL cTitle, cNamePgTable, nSel, lResult
   LOCAL aRet, cVal, aLbl, res, lTable, lSeek := .f.

   //PRIVATE oServer, cQuery, oQuery //, PGoBrw // , fl_server := .f.
   PUBLIC oServer, oQuery

   //    c  TS   ( )
   tStatTimeStamp := HB_DATETIME()

   cFileDbf := SUBSTR( cFileDbf, AtNum( "\", cFileDbf ) + 1 )
   cNamePgTable := SUBSTR( cFileDbf, 1, AtNum( ".", cFileDbf ) - 1 ) //   PG
   cStaticNamePgTable := cNamePgTable  //   

   nSel := SELECT( cAlias )
   IF nSel == 0
      MsgStop( " ! :" + cAlias + "   !" )
      RETURN NIL
   ENDIF
   SELECT( cAlias )
   ? "   " + cFileDbf + "   Postgreesql"

   //  PostgreSQL
   lResult := MyOpen_PostgreSql()
   IF lResult

      //    
      aRet := MyIsTablePgDel( cNamePgTable, M->oServer )  
      IF aRet[1] 
         cVal := aRet[2]  // 
         SetProperty( aLbl[1], aLbl[2], "Value" , cVal ) //  
         RETURN .F.
      ENDIF

      lTable := .F.
      lSeek := .f.
      AEVAL( oServer:ListTables(), { | x | IF( AT( x, LOWER( cNamePgTable ) ) > 0.and.at( LOWER( cNamePgTable ), x ) > 0, lSeek := .t., ) } )
      IF ! lSeek //( ASCAN( oServer:ListTables(), LOWER( cNamePgTable ) ) == 0 )
         ( cAlias ) ->( Create_table_from_Dbf_to_Postgresql( cNamePgTable, DBSTRUCT() ) )

         ? "   Postgreesql :"
         ?v oServer:ListTables() ; ? CRLF
         ? "  : "
         ?v oServer:TableStruct( cNamePgTable ) ; ? CRLF
         //   dbf  PostgreeSql

         IF Copy_table_from_Dbf_to_Postgresql( cNamePgTable, DBSTRUCT(), cAlias )
            ? "  !" + CRLF
            //MsgInfo( "  !" + CRLF + CRLF + "Data transferred !" )
            lTable := .T.
         ELSE
            ? "   !" + CRLF
            MsgStop( "   !" + CRLF + CRLF + "Data is not moved !" )
         ENDIF

      ENDIF

      //     
      cStaticPathTable += LOWER( cNamePgTable )
      //  
      IF lTable
         //   PostgreSQL
         IF Open_PGtable( cNamePgTable , 'Open '+cStaticPathTable, cStaticConnInfo )
            cTitle   := "PostgreSQL Table - " + cStaticPathTable 
            Form_PgSql( cTitle, cNamePgTable ) //    PostgreSQL
            // , ..   ! -> ? "   : ", PQstatus( oServer:pDb() ) ;
            ? cStaticConnInfo
            res := PQping( cStaticConnInfo )
            ? "PQping() = ", res , " -> ", cStaticConnInfo
            IF res == PQPING_OK 
               oServer:Commit()
               ? " : ", GetPingResult( res ) ;  ? CRLF
            ELSE
               ? " : ", GetPingResult( res ) ;  ? CRLF
            ENDIF 
            oServer:Destroy() //  
         ENDIF
      ENDIF // lTable

   ENDIF  // lResult

   RETURN NIL

///////////////////////////////////////////////////////////////////////////////////
FUNCTION Form_PgSql( cTitlHeaderTable, cNamePgTable )
   LOCAL cIco  := "PgSql64", cFont := 'Tahoma', nFontSize := 16
   LOCAL hWnd, nMaxHeight, nMaxWidth, bIClose
   LOCAL cFormName, cTitle := "PostgreSQL -> " + cNamePgTable
   LOCAL nDesktopWidth  := GETDESKTOPREALWIDTH()
   LOCAL nDesktopHeight := GETDESKTOPREALHEIGHT() / 2
   LOCAL aBColorTbr  := COLOR_FRH2
   LOCAL cTbrName :="oBrw2"

   PUBLIC oBrw2

   //     
   WaitThreadCreate( 'Create wintable PostgreSql...', .F. )

   bIClose := _HMG_InteractiveClose
   _HMG_InteractiveClose := 1 // Interactive Close event is disabled

   cFormName  := "Form_Table" + HB_NtoS( _GetId() ) // a unique window name
   cStaticFormTable := cFormName 
   DEFINE WINDOW &cFormName         ;
          AT nDesktopHeight + 5, 0        ;
          WIDTH  nDesktopWidth  ;
          HEIGHT nDesktopHeight - 10 ;
          TITLE cTitle + " (" + cFormName + ")" ;
          ICON cIco                     ;
          WINDOWTYPE STANDARD NOSIZE NOMAXIMIZE ;
          FONT cFont SIZE nFontSize     ;
          BACKCOLOR COLOR_BLUE_VK       ;
          ON INIT { || OnOpenForm(bIClose) , DoMethod( cFormName, "Restore" ) } ;
          ON INTERACTIVECLOSE .T.       ;
          ON RELEASE { || OnCloseForm() }

          hWnd := GetFormHandle( cFormName )
          nMaxWidth  := This.ClientWidth   // GetClientWidth( hWnd )
          nMaxHeight := This.ClientHeight  // GetClientHeight( hWnd )

          /////////////////////// Building TsBrowse PostgreSQL ////////////////////////////
          oBrw2 := CrtTBrw(cTbrName, 10, 10, nMaxWidth - 10 * 2, nMaxHeight - 10 * 2)  

          MyCreateTable2( aBColorTbr, cTitlHeaderTable)
          EndTBrw( oBrw2 )// END TBROWSE

          SetNoHoles( oBrw2 ) //      

   END WINDOW

   // DoMethod( cFormName, "Center"   )
   DoMethod( cFormName, "Activate" )

   RETURN NIL

////////////////////////////////////////////////////////////
STATIC FUNCTION OnOpenForm(bIClose)

   _HMG_InteractiveClose := bIClose //  .

   WaitThreadClose() //  ""

   RETURN NIL

////////////////////////////////////////////////////////////
STATIC FUNCTION OnCloseForm()
   LOCAL cForm := ThisWindow.Name

   IF _IsControlDefined( 'oBrw2', cForm )
      RELEASE oBrw2 //  -  
   ENDIF

   RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION MyOpenPostgreSQL()
   LOCAL lRet := .F.

   IF _IsControlDefined( 'oBrw2', cStaticFormTable )
      lRet := .T.
   ENDIF

   RETURN lRet

////////////////////////////////////////////////////////////
STATIC FUNCTION MyCreateTable2( aBColorTbr, cTableName )
   LOCAL cForm := ThisWindow.Name
   LOCAL hWnd := GetFormHandle( cForm )
   LOCAL hFont, nFontSize, aFontGet, aCursorBC
   LOCAL nI, aMarker[ 2 ], cAlias := ALIAS()
   LOCAL nBackForm   := MyRGB( GetProperty( cForm, "Backcolor" ) )  //   
   LOCAL nBackTable  := MyRGB( aBColorTbr )          //   
   LOCAL nHeadColor1 := MyRGB( COLOR_BLUE_SKYPE  )
   LOCAL nHeadColor2 := MyRGB( {  48,  29, 26  } )  // - 
   LOCAL aHeadColor := YELLOW  //   
   LOCAL aFootColor := YELLOW  //   
   LOCAL nFCount := oQuery:FCOUNT()  // number of fields in the current table

   hFont := oBrw2:hFont         //     
   nFontSize := 10
   IF hFont != Nil
      aFontGet := GetFontParam( hFont )
      nFontSize := aFontGet[ 2 ]  //      
   ENDIF
   WaitThreadSay( "Create col" )   //  .

   //   
   //     \MiniGUI\SOURCE\TsBrowse\h_tbrowse.prg
   PGArrLoadFields( "oBrw2", cForm, .T. )  //   

   //     / Create SUPERHIDER table
   Add SUPER HEADER TO oBrw2 FROM Column 1 TO Column 1 ;
   COLOR CLR_WHITE, { nBackForm, nHeadColor1 } ;
   Title "" 3DLook BITMAP LoadImage( "W_Menu" ) HORZ DT_LEFT

   Add SUPER HEADER TO oBrw2 FROM Column 2 TO Column nFCount + 1 ;
   COLOR CLR_WHITE, { nBackForm, nHeadColor1 } ;
   Title cTableName 3DLook

   //     / We hang SuperHeader treatment table
   FOR nI := 1 TO oBrw2:nColCount()
      oBrw2:aColumns[ nI ]:bHLClicked := { | nRowPix, nCPix, nAt, oBrw | nCPix:=nCPix, nAt:=nAt, IF( nRowPix > oBrw:nHeightSuper,, FunSHeader( oBrw ) ) }
   NEXT

   oBrw2:lNoChangeOrd := .T.  //    
   oBrw2:nColOrder := 0       //     

   // -------------- Fixed cursor ,   ---------
   FOR nI := 1 TO oBrw2:nColCount()
      oBrw2:aColumns[ nI ]:lFixLite := TRUE
   NEXT

   // --------------------     ------------------------------
   oBrw2:SETCOLOR( { 1 }, { { || CLR_WHITE                           } } ) // 1 ,    
   oBrw2:SETCOLOR( { 2 }, { { || nBackTable                          } } ) // 2 ,    
   oBrw2:SETCOLOR( { 3 }, { { || MyRGB( aHeadColor )                   } } ) // 3 ,   
   oBrw2:SETCOLOR( { 4 }, { { || { nHeadColor1, nHeadColor2 }        } } ) // 4 ,   
   oBrw2:SETCOLOR( { 5 }, { { || CLR_BLACK                           } } ) // 5 ,  ,     
   oBrw2:SETCOLOR( { 6 }, { { || { 4915199, 255 }                      } } ) // 6 ,  
   oBrw2:SETCOLOR( { 7 }, { { || CLR_RED                             } } ) // 7 ,   
   oBrw2:SETCOLOR( { 8 }, { { || CLR_YELLOW                          } } ) // 8 ,   
   oBrw2:SETCOLOR( { 9 }, { { || MyRGB( aFootColor )                   } } ) // 9 ,   
   oBrw2:SETCOLOR( { 10 }, { { || { nHeadColor1, nHeadColor2 }        } } ) // 10,   
   oBrw2:SETCOLOR( { 11 }, { { || CLR_GRAY                            } } ) // 11,    (selected cell no focused)
   oBrw2:SETCOLOR( { 12 }, { { || { RGB( 255, 255, 74 ), RGB( 240, 240, 0 ) } } } ) // 12,    (selected cell no focused)
   oBrw2:SETCOLOR( { 13 }, { { || CLR_WHITE                           } } ) // 13,    
   oBrw2:SETCOLOR( { 14 }, { { || CLR_RED                             } } ) // 14,    
   oBrw2:SETCOLOR( { 15 }, { { || CLR_GRAY                            } } ) // 15,    
   oBrw2:SETCOLOR( { 16 }, { { || {  CLR_WHITE, nHeadColor1 }         } } ) // 16,  
   oBrw2:SETCOLOR( { 17 }, { { || CLR_RED                             } } ) // 17,  
   //  :  /   
   aMarker[ 1 ] := MyRGB( YELLOW )
   //aMarker[ 1 ] := Rgb( 163, 163, 163 )   //  15%
   aMarker[ 2 ] := Rgb( 127, 127, 127 )   //  25%
   //     - specialselector header background color
   //oBrw2:nClrSelectorHdBack := CLR_HMAGENTA

   //  :  /   
   aCursorBC := { 4915199, 255 }
   oBrw2:SETCOLOR( { 6 }, { { | a, b, c, d | d:=a, IF( c:nCell == b, aCursorBC , ;
                                              { aMarker[ 1 ], aMarker[ 2 ] } )  }   } )
       
   //     h_tbrowse.prg
   oBrw2:lNoGrayBar  := .t.  //    
   //oBrw2:nAdjColumn  := 3    //        
   //oBrw2:nHeightCell := 32 + 2*2   //    =  
   //oBrw2:nHeightSuper := 60 + 3*2  //   (  )
   //oBrw2:nHeightHead := 30 + 2*2   //    =  
   oBrw2:lNoHScroll  := .T.  //   

   oBrw2:lFooting := .T.     //  
   oBrw2:lDrawFooters := .T. //   
   oBrw2:nHeightFoot  := oBrw2:nHeightHead  //   
   oBrw2:DrawFooters()       //   

   oBrw2:nFreeze     := 1     //  
   oBrw2:lLockFreeze := .T.   //      

   oBrw2:ResetVScroll()      //   

   //    .  
   oBrw2:bChange := { | oBrw | Change2Table( oBrw ) }

   IF oBrw2:nLen == 0  // debugging to look for errors
      MsgDebug( "Stop ! Selection condition TBROWSE == 0 !", "DbSetFilter=", DBFILTER() )
   ENDIF

   // ----------    / reserve for future ----------------
   //oBrw2:bKeyDown := { | nKey | MyKeyAction1(nKey,oBrw2, ThisWindow.Name, 0), lOk := nKey != VK_ESCAPE }
   //oBrw2:bLDblClick:= { || MyAction1(oBrw2, ThisWindow.Name, 0) } //     

   //   
   // oQuery:LastRec() -  -    PostgreSql
   oBrw2:aColumns[ 1 ]:cFooting := { || ALLTRIM( TRANSFORM( oQuery:LASTREC(), "999 999" ) )  }

   oBrw2:Refresh( .T. )

   oBrw2:nCell := 2       //  

   RETURN NIL

////////////////////////////////////////////////////////////
STATIC FUNCTION Change2Table()
   //LOCAL cVal, nLen, cLen
   //LOCAL cForm := oBrw2:cParentWnd

   //oBrw1:nAt -   
   //oBrw1:nCell -   
   //oBrw1:nLen -  -   

   //cVal := HB_NToS( (oBrw1:cAlias)->(OrdKeyNo()) )
   //nLen := (oBrw1:cAlias)->(OrdKeyCount())
   //cLen := HB_NToS( nLen )

   //oBrw1:aColumns[1]:cFooting := { || ALLTRIM(Transform( nLen, "999 999" ))  }
   //oBrw1:aColumns[2]:cFooting := { || " Recno: " + cVal + "/" + cLen }
   //oBrw1:DrawFooters()       //   

   Tbl2Focus()

   RETURN Nil

/////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION Tbl2Focus()
   DoMethod( oBrw2:cParentWnd, oBrw2:cControlName, "SetFocus" )
   RETURN NIL

//////////////////////////////////////////////////////////////////////
FUNCTION MyOpen_PostgreSql()
   LOCAL cHost, cDatabase, cUser, schema, cPort, cPass, cGroup, cTimeout
   LOCAL nPgVersion, aDim, aIp, cInfo, aRet, lRet := .t.

   aDim := Form_SQLconfig()
   IF LEN( aDim ) > 0
      cGroup := aDim[ 1 ]
      aIp := aDim[ 4 ]
      cHost := HB_NtoS( aIp[ 1 ] ) + "." + HB_NtoS( aIp[ 2 ] ) + "." + HB_NtoS( aIp[ 3 ] ) + "." + HB_NtoS( aIp[ 4 ] )
      cPort := HB_NtoS( aDim[ 5 ] )
      cDatabase := aDim[ 6 ] ; cUser := aDim[ 7 ] ; cPass := aDim[ 8 ] ; schema := aDim[ 9 ]
      //    
      cStaticPathTable := cHost + ":" + cPort + "\" + cUser + "\"
      cTimeout := '5'  // 5 sec.

      lRet := MyOpenPgSql(cHost,cPort,cDatabase,cUser,cPass,schema,cTimeout,@aRet)
      nPgVersion := aRet[2]
      cStaticConnInfo := aRet[5]
      //     
      cInfo := "Version server PostgreSQL: " + MyPGVers( nPgVersion )
      SetProperty( "Form_Main", "Label_pgSql2", "Value", cInfo )

   ELSE
      lRet := .F.
   ENDIF // LEN(aDim) > 0

   RETURN lRet

////////////////////////////////////////////////////////////
FUNCTION PGArrLoadFields( ControlName, ParentForm, lEdit, aFieldNames )
   LOCAL ix, PGoBrw 
   DEFAULT lEdit := .f., aFieldNames := {}
   ix := GetControlIndex ( ControlName, ParentForm )
   PGoBrw := _HMG_aControlIds [ ix ]
   IF oQuery:FCOUNT() > 0
      PRBrLoadFields( lEdit, PGoBrw )
 //     PGoBrw:bSkip     := { | n | IF( n == Nil, n := 1, Nil ), PGSkipper( n ) }
   ENDIF
   RETURN PGoBrw

////////////////////////////////////////////////////////////
FUNCTION PRBrLoadFields( lEditable, PGoBrw)

   LOCAL cMsg, n, nE, cHeading, nAlign, nSize, cData, cType, nDec, hFont, cPicture, ;
         nCols, aNames, cKey, ;
         aColSizes := PGoBrw:aColSizes, ;
         cOrder, nEle, ;
         acAlign := { "LEFT", "CENTER", "RIGHT", "VERT" }, ;
         aStru  := oQuery:STRUCT()
  
   LOCAL aArray:={}, aPict:={}, aAlign :={}, aHead:={}, aFSize:={}, aFoot:={} ,aFontHF:={}
   LOCAL aName :={}
   LOCAL nI ,nRow


   DEFAULT lEditable := PGoBrw:lEditable, ;
                        aColSizes := { }

   aNames    := PGoBrw:aColSel
   nCols     := IF( aNames == Nil, oQuery:FCOUNT() , LEN( aNames ) )
   aColSizes := IF( LEN( PGoBrw:aColumns ) == LEN( aColSizes ), Nil, aColSizes )
   cKey := '' ; nEle := 0

   AADD(aHead,"")
   AADD(aPict,"99999999")
   AADD(aAlign,{ DT_CENTER, DT_CENTER, DT_CENTER })
   AADD(aFSize, GetTextWidth( NIL, "0000", hFont ) + 10)  // +10  
   AADD(aName,"NN")
   AADD( aFoot, ""  )

   FOR n := 1 TO nCols

      nE := IF( aNames == Nil, n, oQuery:FIELDPOS( aNames[ n ] )  )

      IF VALTYPE( PGoBrw:aHeaders ) == "A" .and. ! EMPTY( PGoBrw:aHeaders ) .and. n <= LEN( PGoBrw:aHeaders )
         cHeading := PGoBrw:aHeaders[ n ]
      ELSE
         cHeading := PGoBrw:Proper( oQuery:FIELDNAME( nE ) )
      ENDIF

      AADD(aHead,cHeading)
 
      cOrder := ""

      nAlign := IF( PGoBrw:aJustify != Nil .and. LEN( PGoBrw:aJustify ) >= nE, PGoBrw:aJustify[ nE ], ;
                    IF(  VALTYPE( oQuery:FIELDGET( nE ) )  == "N", 2, ;
                        IF(  VALTYPE( oQuery:FIELDGET( nE )  ) == "L", 1, 0 ) ) )

      nAlign := IF( VALTYPE( nAlign ) == "L", IF( nAlign, 2, 0 ), ;
                    IF( VALTYPE( nAlign ) == "C", ASCAN( acAlign, nAlign ) - 1, nAlign ) )

      AADD(aAlign,{ nAlign, DT_CENTER })

      nSize := IF( ! aColSizes == Nil .and. LEN( aColSizes ) >= nE, aColSizes[ nE ], Nil )

      cType := aStru[ nE, 2 ]
      IF cType == "C"
         cPicture := "@K " + REPLICATE( 'X', aStru[ nE, 3 ] )
      ELSEIF cType == "N"
         cPicture := REPLICATE( '9', aStru[ nE, 3 ] )
         IF aStru[ nE, 4 ] > 0
            cPicture := SUBSTR( cPicture, 1, aStru[ nE, 3 ] - aStru[ nE, 4 ] - 1 ) + '.' + REPLICATE( '9', aStru[ nE, 4 ] )
         ENDIF
         cPicture := "@K " + cPicture
      ENDIF

      IF nSize == Nil
         cData := oQuery:FIELDGET( nE )
         cType := aStru[ nE, 2 ]
         nSize := aStru[ nE, 3 ]
         nDec  := aStru[ nE, 4 ]
         hFont := IF( PGoBrw:hFont != Nil, PGoBrw:hFont, 0 )

         IF cType == "C"
            cData := PADR( TRIM( cData ), nSize, "B" )
            nSize := GetTextWidth( 0, cData, hFont )
         ELSEIF cType == "N"
            cData := STRZERO( cData, nSize, nDec )
            nSize := GetTextWidth( 0, cData, hFont )
         ELSEIF cType == "D"
            cData := cValToChar( IF( ! EMPTY( cData ), cData, DATE() ) )
            nSize := INT( GetTextWidth( 0, cData, hFont ) ) + IF( lEditable, 22, 0 )
         ELSEIF cType == "M"
            nSize := IF( PGoBrw:nMemoWV == Nil, 200, PGoBrw:nMemoWV )
         ELSE
            cData := cValToChar( cData )
            nSize := GetTextWidth( 0, cData, hFont )
         ENDIF

         nSize := MAX( GetTextWidth( 0, REPLICATE( "B", LEN( cHeading ) ), hFont ), nSize )
         nSize += IF( ! EMPTY( cOrder ), 14, 0 )

      ELSEIF VALTYPE( PGoBrw:aColSizes ) == "A" .and. ! EMPTY( PGoBrw:aColSizes ) .and. n <= LEN( PGoBrw:aColSizes )
         nSize := PGoBrw:aColSizes[ n ]
      ENDIF

      IF VALTYPE( PGoBrw:aFormatPic ) == "A" .and. ! EMPTY( PGoBrw:aFormatPic ) .and. n <= LEN( PGoBrw:aFormatPic )
         cPicture := PGoBrw:aFormatPic[ n ]
      ENDIF

      AADD(aFSize, nSize)
      AADD(aPict,cPicture)

//      AADD(aHead,oQuery:FIELDNAME( nE ))
      AADD(aName,oQuery:FIELDNAME( nE ))
      //??    //  15.07.2016  
//!!!      ATAIL( PGoBrw:aColumns ):bvalid  := {||ReplaceDataToPg(PGoBrw:aColumns[n]:cData,PGoBrw:aColumns[n]:aData)}
      IF cType == "L"
         //ATAIL( PGoBrw:aColumns ):lCheckBox := .T.
      ENDIF

      IF ! EMPTY( cOrder )
         ATAIL( PGoBrw:aColumns ):lIndexCol := .T.
      ENDIF

      cMsg := HB_NtoS( n ) + "/" + HB_NtoS( nCols )

      AADD( aFoot, ""  )

      WaitThreadSay( cMsg )   //  .

   NEXT

   IF PGoBrw:nLen == 0
      PGoBrw:nLen := IF( PGoBrw:bLogicLen == Nil, EVAL( PGoBrw:bLogicLen := { || oQuery:LASTREC() } ), EVAL( PGoBrw:bLogicLen ) )
   ENDIF
   PGoBrw:bBitMapH := { || 0 }
   oQuery:GOTO( 1 )
   nI := 0   
   While !oQuery:EOF()
      nI++
      AADD(aArray,{})
      AADD(aArray[nI],oQuery:RECNO())
      FOR nRow :=1 to oQuery:nFields
        AADD(aArray[nI],inq(oQuery:FieldGet( nRow )))
      NEXT
      oQuery:Skip( 1 )

   ENDDO
   PGoBrw:SetArrayTo(aArray, aFontHF, aHead, aFSize,;
                                     aFoot, aPict, aAlign, aName )

   RETURN Nil

////////////////////////////////////////////////////////////////////////
STATIC FUNCTION FunSHeader()
   LOCAL cForm := oBrw2:cParentWnd

   MyPopupImageMenuPG( cForm )

   IF _IsWindowDefined( cForm ) //  
      Tbl2Focus()
   ENDIF

   RETURN Nil

////////////////////////////////////////////////////////////////////////////////
FUNCTION MyPopupImageMenuPG( cForm )
   LOCAL hFont, Font1, Font2

   hFont := GetFontHandle( "Font_CM1" ) //  handle  0
   IF hFont == 0
      DEFINE FONT Font_CM1  FONTNAME "Times New Roman" SIZE 16
   ENDIF
   hFont := GetFontHandle( "Font_CM2" ) //  handle  0
   IF hFont == 0
      DEFINE FONT Font_CM2  FONTNAME "Comic Sans MS" SIZE 16 BOLD
   ENDIF

   Font1 := GetFontHandle( "Font_CM1" )
   Font2 := GetFontHandle( "Font_CM2" )

   SET MENUSTYLE EXTENDED
   SetMenuBitmapHeight( 32 )

   DEFINE CONTEXT MENU OF &cForm
       MENUITEM  "   "    ACTION  { || MyPGCreateIndex(1,,cStaticNamePgTable,cStaticConnInfo)    }  FONT Font2 IMAGE "W_index32"
       //MENUITEM  "   "          ACTION  { || MyPGCreateIndex(2)    }  FONT Font2 IMAGE "CheckT28"
       MENUITEM  "   DBF"    ACTION  { || MsgDebug( " 1" )  }  FONT Font2 IMAGE "W_rfrsh_one32"
       MENUITEM  "F5:    "  ACTION  { || MsgDebug( "   !" )    }  FONT Font2 IMAGE "W_rfrsh_all32"
       MENUITEM  "4.   "       ACTION  { || MsgDebug("AddRecno!") }  FONT Font2 IMAGE "W_add32"
       MENUITEM  "5.   DBF  " ACTION  { || MyExportDbf()         }  FONT Font2 IMAGE "W_add32"
       SEPARATOR
       MENUITEM  "  ()"  ACTION  {|| OnCloseForm(), DoMethod(cForm, "Release") }  FONT Font1  IMAGE "W_Close32"
   END MENU

   _ShowContextMenu( cForm, 0, 0, .f. ) //   

   InkeyGui( 10 )  

   IF _IsWindowDefined( cForm ) //  
      DEFINE CONTEXT MENU OF &cForm
      END MENU
   EndIf 

   //  
   RELEASE FONT Font_CM1
   RELEASE FONT Font_CM2

   RETURN NIL

////////////////////////////////////////////////////////////////////////////////
// !!!     STATIC,  .   prg   
//  LOCAL      
FUNCTION CrtTBrw( cBrw, nRow, nCol, nWidth, nHeight, uAlias ) //   TBrowse
LOCAL cForm    := ThisWindow.Name
LOCAL nMrgW    := 10 
LOCAL nMrgH    := 10 
LOCAL FontName := "Tahona" // _HMG_DefaultFontName 
LOCAL FontSize := ModeSizeFont()-2  // _HMG_DefaultFontSize 
LOCAL Value    := 1
LOCAL aImages  := { "br_down" }
LOCAL oBrw, hWnd
LOCAL aHeaders, aWidths, bFields
LOCAL tooltip, change, bDblclick, aHeadClick
LOCAL gotfocus 
LOCAL lostfocus
LOCAL Delete := .F., lNogrid := .F., aJust, HelpId
LOCAL bold := .F., italic := .F., underline := .F., strikeout := .F.
LOCAL break := .F., backcolor, fontcolor
LOCAL lock := .F., nStyle, appendable := .F., readonly
LOCAL valid, validmessages, aColors, uWhen, nId, aFlds, cMsg
LOCAL lRePaint := .T., lEnum := .F., lAutoSearch := .F., uUserSearch
LOCAL lAutoFilter := .F., uUserFilter, aPicture, lTransparent := .F.
LOCAL uSelector, lAutoCol := .F., aColSel

LOCAL cell := .T.          // CELL
LOCAL lEditable := .T.     // EDIT

 hWnd  := GetFormHandle(cForm)

 DEFAULT nRow      := nMrgH,                    ;
         nCol      := nMrgW,                    ;
         nWidth    := GetClientWidth(hWnd),     ;
         nHeight   := GetClientHeight(hWnd)-10, ;
         uAlias    := NIL 
 oBrw := _DefineTBrowse( cBrw,          ;
                         cForm,         ;
                         nCol,          ;
                         nRow,          ;
                         nWidth,        ;
                         nHeight,       ;
                         aHeaders,      ;
                         aWidths,       ;
                         bFields,       ;
                         value,         ;
                         fontname,      ;
                         fontsize,      ;
                         tooltip,       ;
                         change,        ;
                         bDblclick,     ;
                         aHeadClick,    ;
                         gotfocus,      ;
                         lostfocus,     ;
                         uAlias,        ;
                         Delete,        ;
                         lNogrid,       ;
                         aImages,       ;
                         aJust,         ;
                         HelpId,        ;
                         bold,          ;
                         italic,        ;
                         underline,     ;
                         strikeout,     ;
                         break,         ;
                         backcolor,     ;
                         fontcolor,     ;
                         lock,          ;
                         cell,          ;
                         nStyle,        ;
                         appendable,    ;
                         readonly,      ;
                         valid,         ;
                         validmessages, ;
                         aColors,       ;
                         uWhen,         ;
                         nId,           ;
                         aFlds,         ;
                         cMsg,          ;
                         lRePaint,      ;
                         lEnum,         ;
                         lAutoSearch,   ;
                         uUserSearch,   ;
                         lAutoFilter,   ;
                         uUserFilter,   ;
                         aPicture,      ;
                         lTransparent,  ;
                         uSelector,     ;
                         lEditable,     ;
                         lAutoCol,      ;
                         aColSel )

RETURN oBrw
//------------------------------------------------------------------------------
FUNCTION EndTBrw( oBrw )

 _EndTBrowse()

 If ValType(oBrw) == "O" ; SetNoHoles(oBrw)
 EndIf

RETURN NIL



////////////////////////////////////////////////////////////////////////////////
// !!!         PG
FUNCTION MyExportDbf()
   LOCAL cExpFile, aStru, bOldError, lRet, nRec
   LOCAL nRow, rData

   cExpFile := GetStartUpFolder() + "\PgSql-to-"+SUBSTR(cStaticPathTable,RAT("\",cStaticPathTable)+1)+".dbf"

   aStru  := M->oQuery:STRUCT()

   //   
   bOldError := ERRORBLOCK( {|var| BREAK(var)} ) //     
   BEGIN SEQUENCE    
     DbCreate( cExpFile, aStru, "DBFCDX", .T., "TMP", , "RU866" )
     lRet := .T.
   RECOVER
     cMsg := " : ;" + cExpFile + ";" 
     cMsg += "   !;;"
     cMsg := AtRepl( ";", cMsg, CRLF )
     MsgStop( cMsg , "Error" )
     lRet := .F.
   END SEQUENCE
   //       
   ERRORBLOCK( bOldError )

   IF lRet

      nRec := M->oQuery:FCOUNT()
      IF nRec > 0
         SELECT TMP
         oQuery:GOTO( 1 )
         nI := 0   
         While !oQuery:EOF()
           TMP->(DbAppend())
           FOR nRow := 1 TO oQuery:nFields
 //            cData := aStru[nRow,10]
             rData:= inq(oQuery:FieldGet( nRow ))
 //            &("TMP->"+cData):=rData
             FieldPut( nRow, rData )
           NEXT
           oQuery:Skip( 1 )
         ENDDO
      ENDIF
      MsgDebug(cExpFile,aStru,nRec)

      CLOSE TMP
      cMsg := " : ;" + cExpFile + ";" 
      cMsg += "  !;;"
      cMsg := AtRepl( ";", cMsg, CRLF )
      MsgInfo( cMsg , "Info" )

   ENDIF  // IF lRet

   RETURN NIL
