/*
 * MINIGUI - Harbour Win32 GUI library
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"
#include "metrocolor.ch"

MEMVAR nPubTimeUpdate
STATIC nStaticTimeDbf, cStaticStrLog := ""
/*
PROCEDURE MAIN
   LOCAL aDim

   PUBLIC nPubTimeUpdate   := 10  //    - .

   SET LANGUAGE TO RUSSIAN  
   SET CODEPAGE TO RUSSIAN  
   SET NAVIGATION EXTENDED
   SET MULTIPLE OFF WARNING

   SET EPOCH TO ( Year(Date()) - 50 )
   SET DATE FORMAT "DD.MM.YY"
   SET TOOLTIP BALLOON ON
   SET Date TO GERMAN

   DEFINE WINDOW Form_Main AT 0,0     ;
       WIDTH 700 HEIGHT 500           ;
       MAIN                           ;
       TITLE "Test config"            ; 
       ICON "1MAIN_ICO"               ;
       BACKCOLOR COLOR_BLUE_TWIT      ;
       NOMAXIMIZE NOSIZE NOSYSMENU    ;
       ON INIT {|| Form_Main.Hide, ;
                   aDim := Form_SendDbf2PG(), MsgDebug(aDim), ;
                   ThisWindow.Release }  ;

   END WINDOW

   CENTER WINDOW Form_Main
   ACTIVATE WINDOW Form_Main

RETURN
*/
/////////////////////////////////////////////////////////////////////////
FUNCTION Form_SendDbf2PG()
   LOCAL cTitle := "Synchronization settings records"
   LOCAL cIco  := "Dbf64", cFontName := 'Tahoma', nFontSize := 16
   LOCAL aBackColor := COLOR_LIGHT_BLUE 
   LOCAL aButtColor := WHITE, aButtColor2 := BLACK
   LOCAL nFBSize2 := IIF(LargeFonts(),nFontSize-2,nFontSize)
   LOCAL nMaxHeight, nMaxWidth, aRet := {}, aTable := {}
   LOCAL nHButt, nWButt, nRowButt, nColButt, nRow2
   LOCAL nFBSize := IIF(LargeFonts(),8,10)

   DEFINE WINDOW Form_Send            ;
        At 0, 0                       ;
        WIDTH 600 HEIGHT 600          ;
        TITLE cTitle                  ;
        ICON cIco                     ;
        MODAL                         ;
        NOSIZE                        ;
        FONT cFontName SIZE nFontSize ;
        BACKCOLOR aBackColor          ;
        ON INIT { || Form_Send.Label_0.Setfocus }

        nMaxWidth  := This.ClientWidth   
        nMaxHeight := This.ClientHeight

        ////////////////////// button ///////////////////////////////////
        nHButt := 50     // button height
        nWButt := 150    // button width
        nRowButt := nMaxHeight - nHButt - 10

        @ 10, 0 LABEL Label_0 VALUE "   Dbf  PostgreSQL" BOLD SIZE nFontSize + 4;
          WIDTH nMaxWidth HEIGHT (nFontSize+4)*2 ;
          FONTCOLOR WHITE TRANSPARENT CENTERALIGN

        @ 10+(nFontSize)*2, 0 LABEL Label_1 VALUE "Sending records of Dbf to PostgreSQL" BOLD SIZE nFontSize + 4;
          WIDTH nMaxWidth HEIGHT (nFontSize+4)*2 ;
          FONTCOLOR WHITE TRANSPARENT CENTERALIGN

    	@ 84,10 FRAME Frame_1 CAPTION "" BOLD ;
          WIDTH nMaxWidth-10*2 HEIGHT nRowButt - 94 TRANSPARENT

        nRow2 := 120
        @ nRow2, 35 LABEL Label_3 WIDTH 350 HEIGHT 25 ;
          VALUE " /Scan time:"  ;
          TRANSPARENT FONTCOLOR BLACK

        @ nRow2-3, 320 SPINNER Spinner_1 RANGE 1,320 VALUE M->nPubTimeUpdate ;
          WIDTH 55 HEIGHT nFontSize*2 INCREMENT 1 BOLD ;
          ON CHANGE { || M->nPubTimeUpdate := Form_Send.Spinner_1.Value,;
                         Form_Send.Label_Info.Value := InfoMess(),;
                         Form_Send.Label_0.Setfocus  }

        @ nRow2, 390 LABEL Label_4 WIDTH 550 HEIGHT 25 ;
          VALUE "(./sec.)"  ;
          TRANSPARENT FONTCOLOR BLACK

        @ 180, 20 LABEL Label_Info WIDTH nMaxWidth-20*2 HEIGHT 325 ;
          VALUE InfoMess() FONTCOLOR BLUE CENTERALIGN TRANSPARENT 


       nColButt := nMaxWidth - nWButt*2 - 10*2 - nWButt/2
       @ nRowButt, nColButt BUTTONEX Button_Save  ;
          WIDTH nWButt+nWButt/2 HEIGHT nHButt     ;
          CAPTION 'Running send'         ;
          ICON "iSave32x1"               ;
          FONTCOLOR aButtColor           ;
          BACKCOLOR COLOR_GREEN_METRO    ;
          SIZE nFBSize2                  ;
          NOXPSTYLE HANDCURSOR NOTABSTOP ;
          ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iSave32x2") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor2 ) ) ;
          ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iSave32x1") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor ) ) ;
          ACTION { || aRet := { "Run" }, Show_SendDbf2PG(), Form_Send.Release() }   

       nColButt := nMaxWidth - nWButt - 10
       @ nRowButt, nColButt BUTTONEX Button_Exit ;
          WIDTH nWButt HEIGHT nHButt     ;
          ICON "iCancel32x1"             ;
          CAPTION 'Cancel'               ;
          FONTCOLOR aButtColor           ;
          BACKCOLOR COLOR_RED_METRO      ;
          SIZE nFBSize2                  ;
          NOXPSTYLE HANDCURSOR NOTABSTOP ;
          ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iCancel32x2") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor2 ) ) ;
          ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", "iCancel32x1") ,;
                         SetProperty(ThisWindow.Name, This.Name, "fontcolor", aButtColor ) ) ;
          ACTION { || aRet := {}, Form_Send.Release() } 

       ON KEY ESCAPE ACTION ThisWindow.Release

   END WINDOW

   CENTER WINDOW Form_Send
   ACTIVATE WINDOW Form_Send

RETURN aRet

////////////////////////////////////////////////////////
FUNCTION InfoMess()
   LOCAL cInfo

   cInfo := " "+HB_NtoS(M->nPubTimeUpdate)+"     Dbf- "
   cInfo += "    PostgreSQL !" + CRLF
   cInfo += "      TS   ." + CRLF + CRLF
   cInfo += "Every " + HB_NtoS(M->nPubTimeUpdate) + " second the changed records from Dbf-file will be"
   cInfo += " to correspond to PostgreSQL table!" + CRLF
   cInfo += "Changed records are compared across the field TS base and timer." + CRLF + CRLF
   cInfo += "Function call MySyncRecnoDbf2Postgres() !"

   RETURN cInfo

/////////////////////////////////////////////////////////////////////////////////
FUNCTION Show_SendDbf2PG()
   LOCAL cIco := "iConnect32x1", cTitle := "Dbf -> PostgreSQL"
   LOCAL cFont := 'Tahoma', nFontSize := 12
   LOCAL aBackColor := COLOR_LIGHT_ORANGE    //    
   LOCAL nWidth, nHeight, nMaxWidth, nMaxHeight, cMsg

   cMsg := "01:01:00 - 13 . ID=1234, ID=3123" + CRLF 
   cMsg += "01:02:00 - 5 . ID=3123" + CRLF 
   cMsg += "01:03:00 - 3 . ID=" + CRLF 
   cMsg := ""

   nStaticTimeDbf := SECONDS() //     

   nMaxWidth := 420 ; nMaxHeight := 300

IF !IsWindowActive( Form_SendDbf )

   DEFINE WINDOW Form_SendDbf          ;
          At 0, 0                      ;
          WIDTH nMaxWidth              ;
          HEIGHT nMaxHeight            ;
          TITLE cTitle                 ;
          ICON cIco                    ;
          BACKCOLOR aBackColor         ;
          WINDOWTYPE STANDARD          ;
          NOMAXIMIZE NOSIZE            ;
          FONT cFont SIZE nFontSize    ;
          ON INIT { ||  MyInitSendDbf() } ;
          ON RELEASE { || OnCloseSendDbf() } 

          nWidth  := This.ClientWidth   
          nHeight := This.ClientHeight

          @ 5, 0  LABEL Label_Timer VALUE "  - 00:00:00 "    ;
            WIDTH nMaxWidth HEIGHT nFontSize*2  VCENTERALIGN ;
            BOLD FONTCOLOR WHITE TRANSPARENT CENTERALIGN

          @ 5 + nFontSize*2, 10 EDITBOX Edit_Memo               ;
            WIDTH nWidth - 10*2 HEIGHT nHeight-5-nFontSize*2-10 ;
            VALUE cMsg                      ;
            BACKCOLOR COLOR_FRH2            ;
            FONTCOLOR WHITE                 ;
            MAXLENGTH 200 NOHSCROLL READONLY
 
          //DEFINE TIMER Timer_1 INTERVAL M->nPubTimeUpdate * 60 * 1000 ACTION Timer1Dbf()
          DEFINE TIMER Timer_1 INTERVAL M->nPubTimeUpdate * 1000 ACTION Timer1Dbf()
          DEFINE TIMER Timer_2 INTERVAL 100 ACTION Timer2ShowDbf()

   END WINDOW

   //  
   Form_SendDbf.Row := 5
   Form_SendDbf.Col := GetDesktopWidth() - nMaxWidth - 5

   //  
   ACTIVATE WINDOW Form_SendDbf NOWAIT

ELSE   // !IsWindowActive( Form_SendDbf )

   SwitchToWin( "Form_SendDbf" )       //   

ENDIF  // !IsWindowActive( Form_SendDbf )

RETURN NIL

//////////////////////////////////////////////////////////////////////
Function MyInitSendDbf()
    LOCAL cForm := ThisWindow.Name
    LOCAL nMaxWidth, nMaxHeight

    SetProperty(cForm, "Topmost", .T.) 

    nMaxWidth  := Form_SendDbf.Width  
    nMaxHeight := Form_SendDbf.Height 

    Form_SendDbf.Row := 5
    Form_SendDbf.Col := GetDesktopWidth() - nMaxWidth - 5

    Form_SendDbf.Label_Timer.Setfocus

    RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION OnCloseSendDbf()
    Form_SendDbf.Timer_2.Enabled := .F. //   
    Form_SendDbf.Timer_1.Enabled := .F. //  
    RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION Timer2ShowDbf() //  
    LOCAL cForm := "Form_SendDbf" //ThisWindow.Name
    LOCAL cTime, cVal, nTime := M->nPubTimeUpdate //* 60

    IF _IsWindowActive( cForm )
       cTime := SECTOTIME( nTime - (SECONDS() - nStaticTimeDbf) )
       cVal := GetProperty( cForm, "Label_Timer" , "Value" )
       cVal := SUBSTR(cVal,1,AT("-",cVal)+1) + cTime
       SetProperty( cForm, "Label_Timer" , "Value", cVal )
    ENDIF

    RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION Timer1Dbf() //    

    Form_SendDbf.Timer_2.Enabled := .F. //   
    Form_SendDbf.Timer_1.Enabled := .F. //  

    //MsgDebug("Checking the timer calls Timer1Dbf() !")
    MySyncRecnoDbf2Postgres()

    nStaticTimeDbf := SECONDS() //     

    Form_SendDbf.Timer_2.Enabled := .T. //   
    Form_SendDbf.Timer_1.Enabled := .T. //  

    RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION LogTimer1Dbf(cStr) //    
    LOCAL cMsg, cForm := "Form_SendDbf" // ThisWindow.Name

    cMsg := cStr  + CRLF + cStaticStrLog
    cStaticStrLog := cMsg
    IF _IsWindowActive( cForm )
       SetProperty( cForm, "Edit_Memo" , "Value", cMsg )
    ENDIF

    RETURN NIL
