/*
 * MINIGUI - Harbour Win32 GUI library
*/

#include "minigui.ch"

#define COPYRIGHT "(c) Copyright by Andrey Verchenko. 2000-2016. All rights reserved. Dmitrov, Russia"
#define INI_FILE_WIN_CFG  ChangeFileExt( Application.ExeName, ".cfg" ) 

/////////////////////////////////////////////////////////////////////
Function IniSetIsFilePG(FormName, cProgName, cProgSection)
   Local cText, aDim, cSection, cFileIni := INI_FILE_WIN_CFG
   Default FormName := _HMG_ThisFormName
   Default cProgName := GetProperty(FormName, "Title")
   Default cProgSection := ""
   cSection := FormName + "/" + cProgSection
                                    
   IF ! File( cFileIni )
      cText := "[Information]" + CRLF
      cText += "Program = " + Application.ExeName + CRLF
      cText += "Author  = " + COPYRIGHT + CRLF
      cText += "Free Open Source Software = " + Version() + CRLF
      cText += "Free Compiler = " + hb_compiler() + CRLF
      cText += "Free Library  = " + MiniGUIVersion() + CRLF
      cText += "" + CRLF
      cText += "[RUSSIAN]" + CRLF + CRLF
      HB_MemoWrit( cFileIni, cText )
   ENDIF

   aDim := {}
   AADD( aDim, "Server-Test"                     )
   AADD( aDim, "Test database server to Internet")
   AADD( aDim, "The test server for testing"     )
   AADD( aDim, {127, 0, 0, 1}                    )
   AADD( aDim, 5432                              )
   AADD( aDim, "postgres"                        )
   AADD( aDim, "UserName"                        )
   AADD( aDim, "psw1234567890"                   )
   AADD( aDim, "public"                          )

   IF ! IsINISection(cFileIni, cSection) 
      //    ,    
      WriteIni( cSection, "TitleWin" , cProgName , cFileIni )
      WriteIni( cSection, "pgGroup"  , aDim[1]   , cFileIni ) 
      WriteIni( cSection, "pgName"   , aDim[2]   , cFileIni ) 
      WriteIni( cSection, "pgRem"    , aDim[3]   , cFileIni ) 
      WriteIni( cSection, "pgIp"     , HB_ValToExp(aDim[4]), cFileIni ) 
      WriteIni( cSection, "pgPort"   , HB_NtoS(aDim[5])    , cFileIni ) 
      WriteIni( cSection, "pgDb"     , aDim[6]   , cFileIni ) 
      WriteIni( cSection, "pgUser"   , aDim[7]   , cFileIni ) 
      WriteIni( cSection, "pgPass"   , aDim[8]   , cFileIni ) 
      WriteIni( cSection, "pgShema"  , aDim[9]   , cFileIni ) 
   ENDIF

Return Nil

/////////////////////////////////////////////////////////////////////
Function IniGetPG( FormName, cProgName, cProgSection )
   Local cSection, aDim[9], cFileIni := INI_FILE_WIN_CFG
   Default FormName := _HMG_ThisFormName
   Default cProgName := GetProperty(FormName, "Title")
   Default cProgSection := ""
   cSection := FormName + "/" + cProgSection

   aDim[1] := GetIni( cSection , "pgGroup" , "*", cFileIni )        
   aDim[2] := GetIni( cSection , "pgName"  , "*", cFileIni )        
   aDim[3] := GetIni( cSection , "pgRem"   , "*", cFileIni )
   aDim[4] := &(   GetIni( cSection, "pgIp", '{0,0,0,0}' , cFileIni ) ) 
   aDim[5] := VAL( GetIni( cSection, "pgPort", "0", cFileIni ) )
   aDim[6] := GetIni( cSection , "pgDb"    , "*", cFileIni )        
   aDim[7] := GetIni( cSection , "pgUser"  , "*", cFileIni )        
   aDim[8] := GetIni( cSection , "pgPass"  , "*", cFileIni )        
   aDim[9] := GetIni( cSection , "pgShema" ,  "", cFileIni )        

   Return aDim

/////////////////////////////////////////////////////////////////////
Function IniSetPG( FormName, cProgName, cProgSection, aDim )
   Local cSection, cFileIni := INI_FILE_WIN_CFG
   Default FormName := _HMG_ThisFormName
   Default cProgName := GetProperty(FormName, "Title")
   Default cProgSection := ""
   cSection := FormName + "/" + cProgSection

   WriteIni( cSection, "pgGroup"  , aDim[1]   , cFileIni ) 
   WriteIni( cSection, "pgName"   , aDim[2]   , cFileIni ) 
   WriteIni( cSection, "pgRem"    , aDim[3]   , cFileIni ) 
   WriteIni( cSection, "pgIp"     , HB_ValToExp(aDim[4]), cFileIni ) 
   WriteIni( cSection, "pgPort"   , HB_NtoS(aDim[5])    , cFileIni ) 
   WriteIni( cSection, "pgDb"     , aDim[6]   , cFileIni ) 
   WriteIni( cSection, "pgUser"   , aDim[7]   , cFileIni ) 
   WriteIni( cSection, "pgPass"   , aDim[8]   , cFileIni ) 
   WriteIni( cSection, "pgShema"  , aDim[9]   , cFileIni ) 
   
Return Nil

*--------------------------------------------------------*
STATIC Function GetIni( cSection, cEntry, cDefault, cFile )
RETURN GetPrivateProfileString(cSection, cEntry, cDefault, cFile )
*--------------------------------------------------------*
STATIC Function WriteIni( cSection, cEntry, cValue, cFile )
RETURN( WritePrivateProfileString( cSection, cEntry, cValue, cFile ) )
*--------------------------------------------------------*
STATIC Function IsINISection(cIniFile, cName)
Return ( aScan( _GetSectionNames(cIniFile), {|x| UPPER(x) == UPPER(cName)} ) > 0 )
*--------------------------------------------------------*
//STATIC Function IsVarINISection(cIniFile, cSecName, cName) 
//Return ( aScan( _GetSection(cSecName, cIniFile), {|x| UPPER(x[1]) == UPPER(cName)} ) > 0 ) 

