/* 
///////////////////////////////////////////////////////////////////////////////
//       :
   
   nTime := SECONDS()

   //     
   WaitThreadCreate( '  ...' )

   //   //   .. 
   ...................

   WaitThreadClose()   //   "" 

   cMsg := "    " + SECTOTIME( SECONDS() - nTime ) 
   MsgInfo(cMsg)

*/
//////////////////////////////////////////////////////////////////////////////
/*
 * MINIGUI - Harbour Win32 GUI library 
 *   Harbour / Streams in Harbour
 *   MiniGui / Streams in MiniGui
 *   MiniGui / Preloader in MiniGui
 *
 * Copyright 2015 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2015 Grigory Filatov <gfilatov@inbox.ru>
*/
#include "hmg.ch"
#include "hbthread.ch" 

//   -  "" / the name of the form - the window "waiting"
STATIC cStatWinWait  := ""  
//      ""/ for the start of the cycle in the window "waiting"
STATIC lStatWinWait  := .T. 
//     "" / an array of images to window "waiting"
STATIC aStatPictWait := {"FR01","FR02","FR03","FR04","FR05","FR06","FR07","FR08",;
                              "FR09","FR10","FR11","FR12"}

//////////////////////////////////////////////////////////////////////////////
FUNCTION WaitThreadCreate( cTitle, lModal ) 
   LOCAL cFormName := "WaitWin_" + HB_NtoS( _GetId() ) 
   LOCAL cFont := 'Tahoma', nFontSize := 12
   LOCAL nTxtWidth, lFor := .T., nWinWidth := 420 
   DEFAULT cTitle := "Working...", lModal := .T.

   // transfer window name "standby" in the public variable
   //    ""  public 
   cStatWinWait := cFormName  
   // To start an infinite loop in the flow preloding
   //     preloding  
   lStatWinWait := .T.  

   SET INTERACTIVECLOSE OFF

   //   ,     
   DO WHILE lFor
      nTxtWidth := GetTxtWidth( cTitle , nFontSize, cFont) + 40
      IF nTxtWidth > nWinWidth 
         nFontSize--    
      ELSE
         lFor := .F.
      ENDIF
   ENDDO

   SetCursorSystem( IDC_WAIT )

IF lModal
   DEFINE WINDOW &cFormName ;
     ROW 0 COL 0            ;
     WIDTH 420 HEIGHT 230   ;
     TITLE ''               ;
     MINWIDTH 420 MINHEIGHT 230 ; 
     MAXWIDTH 420 MAXHEIGHT 230 ;
     MODAL NOCAPTION            ;
     BACKCOLOR WHITE            ;
     ON INIT {|| ProcessMessages() } ;
     ON MOUSECLICK MoveActiveWindow() 
ELSE
   DEFINE WINDOW &cFormName ;
     ROW 0 COL 0            ;
     WIDTH 420 HEIGHT 230   ;
     TITLE ''               ;
     MINWIDTH 420 MINHEIGHT 230 ; 
     MAXWIDTH 420 MAXHEIGHT 230 ;
     CHILD NOCAPTION            ;
     BACKCOLOR WHITE            ;
     ON INIT {|| ProcessMessages() } ;
     ON MOUSECLICK MoveActiveWindow() 
ENDIF
 
     @ 10,100 LABEL Label_1  ;
       WIDTH 400-100 HEIGHT 30  ;
       VALUE "Elapsed time 00:00:00" ;
       CENTERALIGN VCENTERALIGN TRANSPARENT

     @ 10,10 LABEL Label_0  ;
       WIDTH 140 HEIGHT 30  ;
       VALUE ""  ;
       VCENTERALIGN TRANSPARENT

     @ 40, (420-128)/2 IMAGE Image_1 PICTURE aStatPictWait[1] ;
       WIDTH 128 HEIGHT 128 ;
       WHITEBACKGROUND TRANSPARENT

     @ 40 + 128 + 10, 10 LABEL Label_2   ;
       WIDTH 400 HEIGHT 30               ;
       VALUE cTitle                      ;
       CENTERALIGN VCENTERALIGN TRANSPARENT

     SetWaitCursor( Thiswindow.Handle )

   END WINDOW

   Center Window &cFormName
   Activate Window &cFormName NoWait

   // Start preloding in a separate thread
   //  preloding   
   hb_threadDetach(hb_threadStart(HB_THREAD_INHERIT_MEMVARS, @WaitThreadTimer(), SECONDS() ))

  RETURN NIL

//////////////////////////////////////////////////////////////////////
FUNCTION WaitThreadClose()

   //     / complete function in the stream
   lStatWinWait := .F.  
   InkeyGui(100) 

   SET INTERACTIVECLOSE ON

   Domethod(cStatWinWait,"Release")

   SetCursorSystem( IDC_ARROW )

   DO MESSAGE LOOP

RETURN NIL

//////////////////////////////////////////////////////////////////////////////
FUNCTION WaitThreadTimer(nTime)
   // Variable nTime equal SECONDS () - gives an example of the transmission
   //  nTime  SECONDS() -     
   LOCAL cFormName, nLogo := 1 , lExit := .T., cTime

   cFormName := cStatWinWait

   DO WHILE lStatWinWait

      cTime := "Elapsed time " + SECTOTIME( SECONDS() - nTime )

      nLogo ++  //   
      nLogo := IIF( nLogo > LEN( aStatPictWait ), 1, nLogo )

      SetProperty( cFormName, "Label_1", "Value", cTime )
      SetProperty( cFormName, "Image_1", "Picture", aStatPictWait[ nLogo ] )

      InkeyGui(20) 

   ENDDO

   RETURN NIL

//////////////////////////////////////////////////////////////////////////////
FUNCTION WaitThreadSay(cVal)   //  .
   LOCAL cFormName := cStatWinWait

   SetProperty( cFormName, "Label_0", "Value", cVal )
   DO EVENTS 

   RETURN NIL

/////////////////////////////////////////////////
#define HTCAPTION          2
#define WM_NCLBUTTONDOWN   161

PROCEDURE MoveActiveWindow( hWnd )
   DEFAULT hWnd := GetActiveWindow()

   PostMessage( hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0 )

   RC_CURSOR( "Grabbed32" )
   RETURN
