/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2016 Grigory Filatov  <gfilatov@inbox.ru>
*/

#include "minigui.ch"
#include "metrocolor.ch"
#include "mydefines.ch"

REQUEST HB_CODEPAGE_RU1251, HB_CODEPAGE_RU866
REQUEST DBFCDX, DBFFPT

MEMVAR lPubIndexOpenDbf, lPubIndexOpenPG, nPubTimeUpdate

PROCEDURE MAIN
   LOCAL nWidth, nHeight, aBackColor, nLbl0, nLblCol
   LOCAL nJ, aDim[3], cFont := "Tahona", nFontSize := 14
   LOCAL cFileDbf := GetStartUpFolder() +"\test.dbf"
   LOCAL cAlias, aRet, cFileLog

   PUBLIC lPubIndexOpenDbf := .F. //     
   PUBLIC lPubIndexOpenPG  := .F. //   "primary key"  
   PUBLIC nPubTimeUpdate   := 10  //    - .

   SET LANGUAGE TO RUSSIAN  
   SET CODEPAGE TO RUSSIAN  
   SET MULTIPLE OFF WARNING
   SET NAVIGATION EXTENDED

   SET EPOCH TO ( Year(Date()) - 50 )
   SET DATE FORMAT "DD.MM.YY"
   SET TOOLTIP BALLOON ON
   SET Date TO GERMAN

   SET DELETED ON
   RDDSETDEFAULT('DBFCDX')

   //      -  MLog(...) -> util_MiniGui6.prg
   cFileLog := ChangeFileExt( Application.ExeName, ".log" )
   DELETEFILE(cFileLog)
   SET LOGFILE TO &cFileLog 
   ? "=======================    - "+TIME() + "  ======================="  
   
   IF !hb_mtvm()
      MsgStop ("No support for multi-threading!" + CRLF + CRLF + ;
                "Compiling with a key /mt" + CRLF )
      QUIT
   ENDIF

   aDim[1] := "Example of creating a file-Dbf"  
   aDim[2] := "to PostgreSQL database"  
   aDim[3] := MiniGUIVersion()  

   SET FONT TO cFont , nFontSize 

   DEFINE WINDOW Form_Main AT 0,0     ;
       WIDTH 700 HEIGHT 520           ;
       MAIN                           ;
       TITLE PROGRAM                  ; 
       ICON "1MAIN_ICO"               ;
       BACKCOLOR COLOR_BLUE_TWIT      ;
       NOMAXIMIZE NOSIZE              ;
       ON INIT { || OnInitFormaMain(cFileDbf) }  ;
       ON RELEASE { || OnCloseFormaMain(cFileDbf) } 

       nWidth  := This.ClientWidth  
       nHeight := This.ClientHeight  
       aBackColor := COLOR_BLUE_FB

       nLbl0 := 100
       @ 0, 0 LABEL Label_0 WIDTH nWidth HEIGHT nLbl0 VALUE "" ;
         FONT cFont SIZE nFontSize BOLD  CENTERALIGN ;
         FONTCOLOR aBackColor BACKCOLOR aBackColor  VCENTERALIGN

       @ 2, 20 IMAGE Image_1 PICTURE 'LOGO' WIDTH 96 HEIGHT 96 STRETCH ;
         TRANSPARENT BACKGROUNDCOLOR aBackColor ;
         ACTION MsgAbout() OnMouseHover RC_CURSOR( "MINIGUI_FINGER" )

       nJ := nLbl0/3 
       nLblCol := Form_Main.Image_1.Width + Form_Main.Image_1.Col + 5
       @ 0, nLblCol LABEL Label_1 WIDTH nWidth-nLblCol HEIGHT nJ VALUE aDim[1] ;
          FONT cFont SIZE nFontSize*1.3 BOLD  CENTERALIGN ;
          FONTCOLOR YELLOW BACKCOLOR aBackColor  VCENTERALIGN
       @ nJ*1, nLblCol LABEL Label_2 WIDTH nWidth-nLblCol HEIGHT nJ VALUE aDim[2] ;
          FONT cFont SIZE nFontSize*1.3 BOLD  CENTERALIGN ;
          FONTCOLOR YELLOW BACKCOLOR aBackColor  VCENTERALIGN
       @ nJ*2, nLblCol LABEL Label_3 WIDTH nWidth-nLblCol HEIGHT nJ VALUE aDim[3] ;
          FONT cFont SIZE nFontSize BOLD  CENTERALIGN ;
          FONTCOLOR YELLOW BACKCOLOR aBackColor  VCENTERALIGN

       @ nLbl0 + 20, 20  LABEL Label_pgSql1 VALUE "Version dll PostgreSQL" ;
         WIDTH nWidth-40 HEIGHT 30 FONTCOLOR BLACK BOLD TRANSPARENT 

       @ nLbl0 + 50, 20  LABEL Label_pgLib  VALUE "Version libpq.lib" ;
         WIDTH nWidth-40 HEIGHT 30 FONTCOLOR BLACK BOLD TRANSPARENT 

       @ nLbl0 + 80, 20  LABEL Label_pgSql2 VALUE "Version server PostgreSQL" ;
         WIDTH nWidth-40 HEIGHT 30 FONTCOLOR BLACK BOLD TRANSPARENT 

       @ 230,40 BUTTONEX Button_Dbf CAPTION 'Open' + CRLF + 'Dbf-file';
          WIDTH 360 HEIGHT 110 BACKCOLOR COLOR_BLUE_BLUE FONTCOLOR WHITE BOLD ;
          ICON "Dbf64" NOXPSTYLE HANDCURSOR ACTION { |lRet| aRet := MyOpenDbf(), lRet := !empty(aRet),;
                                                     iif( lRet, cAlias   := aRet[1], ), ; 
                                                     iif( lRet, cFileDbf := aRet[2], ), ; 
                                                     iif( lRet, Form_Main.Button_pgSql.Enabled := .T., ) ,;
                                                     iif( lRet, Form_Main.Button_Dbf.Enabled   := .F., ) ,;
                                                     iif( lRet, MyTableDbf(cAlias,cFileDbf)          , ) ,;
                                                     iif( lRet, Form_Main.Button_Dbf.Enabled := .T.  , ) ,;
                                                     Form_Main.Restore   }

       @ 350,40 BUTTONEX Button_pgSql CAPTION 'New' + CRLF + 'PostgreSQL database' + CRLF + 'from Dbf-file' ;
          WIDTH 360 HEIGHT 110 BACKCOLOR COLOR_BLUE_VK FONTCOLOR WHITE BOLD ;
          ICON "PgSql64" NOXPSTYLE HANDCURSOR ACTION {|| Form_Main.Minimize,;
                                                         Form_Main.Button_pgSql.Enabled := .F. ,;
                                                         MyPgSql(cAlias,cFileDbf),; 
                                                         Form_Main.Button_pgSql.Enabled := .T. ,;
                                                         Form_Main.Restore   }

       @ 230,410 BUTTONEX Button_Help CAPTION 'About' + CRLF + 'the program' ;
          WIDTH 250 HEIGHT 110 BACKCOLOR COLOR_YELLOW_METRO FONTCOLOR WHITE BOLD ;
          ICON "help64" NOXPSTYLE HANDCURSOR ACTION  {|| MsgAbout() }

       @ 350,410 BUTTONEX Button_Exit CAPTION 'Exit'                          ;
          WIDTH 250 HEIGHT 110 BACKCOLOR COLOR_RED_METRO FONTCOLOR WHITE BOLD ;
          ICON "Close64" NOXPSTYLE HANDCURSOR ACTION  {|| ThisWindow.Release }

   END WINDOW

   CENTER WINDOW Form_Main
   ACTIVATE WINDOW Form_Main

RETURN

////////////////////////////////////////////////////////////
FUNCTION OnInitFormaMain(cFileDbf)
   LOCAL hWnd := GetFormHandle( ThisWindow.Name )
   LOCAL cInfo, nVers, bButton_Dbf
   
   MyDbf(cFileDbf)  //   
   
   IniSetIsFilePG("Connect","","Group 1") //    -

   //     PQlibVersion()   postgres.c
   nVers := PQlibVersion()  
   cInfo := "Version libpq.lib: " + MyPGVers(nVers) 
   Form_Main.Label_pgLib.Value := cInfo
  
   //     libpq.dll -> use_Postgres.prg
   nVers :=  PQDllVersion()   
   cInfo := "Version dll PostgreSQL: " + MyPGVers(nVers)
   Form_Main.Label_pgSql1.Value := cInfo
   
   cInfo := "Version server PostgreSQL: ???" //      
   Form_Main.Label_pgSql2.Value := cInfo
  
   Form_Main.Button_pgSql.Enabled := .F.
   
   //    Button_Dbf
   Form_Main.Button_Dbf.Setfocus

   bButton_Dbf := Form_Main.Button_Dbf.Action
   if valtype(bButton_Dbf) == 'B'
      Eval(bButton_Dbf)
   endif

   Form_Main.Image_1.Setfocus

   RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION OnCloseFormaMain(cFileDbf)  
   LOCAL cFileIndex1 := cFileDbf + "1.cdx"
   LOCAL cFileIndex2 := cFileDbf + "2.cdx"

   DbCloseAll()
   //DELETEFILE(cFileDbf)
   DELETEFILE(cFileIndex1)
   DELETEFILE(cFileIndex2)
   ? "=======================    - "+TIME() + "  ======================="  

   RETURN NIL
