/*
 * PostgreSQL the file extension -> tpostgre.prg
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016-2017 Verchenko Andrey <verchenkoag@gmail.com> 
 * Copyright 2016-2017 Sidorov Aleksandr <aksidorov@mail.ru>
 *
 */

MEMVAR oServer, oQuery
STATIC cQuery

#include "minigui.ch"
#include "postgres.ch"
#include "hbdyn.ch"

//////////////////////////////////////////////////////////////////////////////
//       PgSql
FUNCTION RemoveQuotes(cStr)
   IF AT("'",cStr) > 0
      cStr := CHARREM("'",cStr)
   ENDIF
   IF AT('"',cStr) > 0
      cStr := CHARREM('"',cStr)
   ENDIF
   cStr := MEMOTRAN(cStr,' ',' ')
   cStr := StrTran( cStr, ""+CHR(10), " " ) 
   cStr := StrTran( cStr, ""+CHR(13), " " ) 
   cStr := StrTran( cStr, CHR(10), " " ) 
   cStr := StrTran( cStr, CHR(13), " " ) 
   RETURN cStr 


//////////////////////////////////////////////////////////////////////////////
//     libpq.dll
FUNCTION PQDllVersion()
   RETURN hb_DynCall( { "PQlibVersion", "libpq.dll", HB_DYN_CTYPE_INT } ) 

//////////////////////////////////////////////////////////////////////////////
FUNCTION MyOpenPgSql(cHost,cPort,cDatabase,cUser,cPass,schema,cTimeout,aRet)
   LOCAL nPgVersion, conn, cInfo, cPathTable, cVerPg, cValConnInfo, lRet := .t.
   LOCAL nResultStatus
   DEFAULT cTimeout := '5'  // 5 sec.
   DEFAULT aRet := {'none',"-1", "Version server PostgreSQL -1", "not path",""} 

      //    
      cPathTable := cHost + ":" + cPort + "\" + cUser + "\"

      //     
      //WaitThreadCreate( '  PostgreSQL ...' )
      //WaitThreadSay( cTimeout + " sec" )   //  .
      //SetWaitCursor( Thiswindow.Handle )
      SetArrowCursor( Application.Handle )

      //  , ..  TPQServer():NEW()   timeout 
      conn := PQconnectdb( "dbname = " + cDatabase + " host = " + cHost + " user = " + cUser + ;
                       " password = " + cPass + " port = " + cPort + " connect_timeout = " + cTimeout)

      cValConnInfo := hb_strFormat( "host = %1$s port = %2$s connect_timeout = %3$s", cHost, cPort, cTimeout ) 
      ? cValConnInfo

      ? "PQstatus() = ", PQstatus( conn ) ; ? '+'

      IF PQstatus( conn ) != CONNECTION_OK
         //WaitThreadClose()   //   ""
         //SetArrowCursor( Thiswindow.Handle )
         SetArrowCursor( Application.Handle )
         cInfo := "    PostgreSQL !" + CRLF + CRLF
         cInfo +=  ": " + PQerrorMessage( conn )  
         ? cInfo ; ? '+'  
         MsgStop( cInfo + CRLF + CRLF + cValConnInfo , "!" )
         lRet := .f.
         RETURN lRet
      ELSE
         nPgVersion := PQSERVERVERSION( conn )
         //     
         cVerPg := "Version server PostgreSQL: " + MyPGVers( nPgVersion )
         //SetProperty( "Form_Main", "Label_pgSql2", "Value", cInfo )
         ? cVerPg 
      ENDIF



      M->oServer := TPQServer():NEW( cHost, cDatabase, cUser, cPass,, schema )

      ? "New TPQServer()  PQstatus( oServer:pDb() ) = ", PQstatus( M->oServer:pDb() )  
      ? '+'

      //WaitThreadClose()   //   ""
      //SetArrowCursor( Thiswindow.Handle )
      SetArrowCursor( Application.Handle )

      IF M->oServer:NETERR()
         ? "  SQL  :", M->oServer:ErrorMsg() ; ? '+'
         MsgStop( "Failed to open SQL server !" + CRLF + M->oServer:ErrorMsg() )
         lRet := .f.
      ENDIF

   aRet := {conn,nPgVersion,cVerPg,cPathTable,cValConnInfo}

   RETURN lRet

///////////////////////////////////////////////////////////////////////////////////
//     ,      ,
//    .    
//  ,        
//    . ,   8.1.5    80105,
//    8.2    80200 (   ).
//    ,   .
FUNCTION MyPGVers( nVal )
   RETURN  CHARREPL( '0', HB_NtoS( nVal ), '.' )

///////////////////////////////////////////////////////////////////////////////////
//    
FUNCTION MyIsTablePg( cNamePgTable, oSrvPg )
   LOCAL oTbl, cTable, cInfo, cErr, lSeek := .f. 

   cTable :=  LOWER( cNamePgTable )
   oTbl := oSrvPg:ListTables()
   ? cNamePgTable
   ? "   PostgreSql : "
   ?? oTbl  ;  ? "-"
   ?v oTbl ;  ? "-"

   AEVAL( oTbl, { | x | IF( AT( x, cTable ) > 0.and.at( cTable , x ) > 0, lSeek := .t., ) } )

   ? "MyIsTablePg("+cTable+") := ", lSeek ;  ? "-"

   RETURN lSeek

///////////////////////////////////////////////////////////////////////////////////
//    
FUNCTION MyIsTablePgDel( cNamePgTable, oSrvPg )
   LOCAL oTbl, cInfo, cErr, lSeek := .f. , aRet := {.F., " " }

   oTbl := oSrvPg:ListTables()
   ? cNamePgTable
   ? "   PostgreSql  :"
   ? oTbl  ;  ? CRLF
   ?v oTbl ;  ? CRLF

   AEVAL( oTbl, { | x | IF( AT( x, LOWER( cNamePgTable ) ) > 0.and.at( LOWER( cNamePgTable ), x ) > 0, lSeek := .t., ) } )
   IF lSeek //( ASCAN( oServer:ListTables(), LOWER( cNamePgTable ) ) == 0 )
      cInfo := " [" + LOWER( cNamePgTable ) + "]   "
      ? cInfo
      cInfo += "!;;       DBF ?;;"
      cInfo += REPLICATE( "-._.", 22 ) + ";;"
      cInfo := AtRepl( ";", cInfo, CRLF )
      IF MsgYesNo( cInfo, "  ?", .F. )
         ? "     : ", cNamePgTable  ;  ? "-"
         oSrvPg:DeleteTable( LOWER( cNamePgTable ) )

         IF oSrvPg:NETERR()
            cErr := "   [" + LOWER( cNamePgTable ) + "]   :"
            cErr += oSrvPg:ErrorMsg() 
            ? cErr ;  ? "-"
            //break
            aRet := { .T., cErr }
         ENDIF

      ELSE
         aRet := { .T., " [" + LOWER( cNamePgTable ) + "]   !" }
      ENDIF

   ENDIF

   RETURN aRet

////////////////////////////////////////////////////////////
FUNCTION Open_PGtable( cTable, cTableMsg, cConnInfo )
   LOCAL cMsg, cFile, lRet := .t.

   //     
   WaitThreadCreate( 'Open '+cTableMsg, .F. ) //  
   WaitThreadSay( '0/0' )   //  .
   ? "  ", cTableMsg ; ? '+'

   //oQuery := oServer:Query("SELECT * FROM tklients WHERE tklients.k1="+OUQ(Field->K1)+" and tklients.k2="+OUQ(Field->K2))
   oQuery := oServer:Query( "SELECT * FROM " + cTable )
   IF oQuery:LASTREC() == 0    // 
      cMsg := "        " + cTable + " !;;"
      cMsg += REPLICATE( "-._.", 22 ) + ";;"
      cMsg += "No records found when asked to read in the " + cTable + " !;;"
      cMsg := AtRepl( ";", cMsg, CRLF )
      MsgStop( cMsg )
      ? "        ", cTable ; ? '-'
      lRet := .f.
   ELSE
      //MsgInfo( " " + STR( oQuery:LASTREC() ) + "   " + cTable )
   ENDIF

   WaitThreadClose() //  ""

   RETURN lRet

////////////////////////////////////////////////////////////////////////////////
FUNCTION MyPGCreateIndex(nFlag,aIndex,cNamePgTable,cConnInfo)
   LOCAL res, cMsg, aTblStruct, aRet, cQuery, nResultStatus
   DEFAULT nFlag := 1, aIndex := {}

   cMsg := ""
   //   
   aTblStruct := M->oServer:TableStruct( cNamePgTable ) 
   IF nFlag == 0 
      aRet := aIndex
   ELSE
      aRet := Form_SQLindex(aTblStruct,cNamePgTable)
   ENDIF
   IF LEN(aRet) > 0

      cQuery := aRet[1]
      res := PQping( cConnInfo ) //   
      IF res == PQPING_OK 
         res := PQexec( oServer:pDB, cQuery )
         cMsg := "  : " + cQuery + CRLF
         nResultStatus := PQresultStatus( res )
         IF nResultStatus == PGRES_COMMAND_OK
            cMsg +=  ": " + GetResultStatus( nResultStatus, 2 ) + CRLF
            IF nFlag > 0 ; MsgInfo( cMsg )
            ENDIF 
            //   "primary key"  
            M->lPubIndexOpenPG  := .T. 
         ELSE
            cMsg +=  ": " + GetResultStatus( nResultStatus, 2 ) + " - " 
            cMsg +=  GetResultStatus( nResultStatus, 3 ) + CRLF
            IF nFlag > 0 ; MsgStop( cMsg ) 
            ENDIF 
         ENDIF
         ? cMsg  
      ELSE
         cMsg := " : " + GetPingResult( res ) + CRLF + "  ."
         ? cMsg
         MsgStop(cMsg)
      ENDIF 
   ENDIF // LEN(aRet) > 0

   RETURN cMsg

////////////////////////////////////////////////////////////////////////////////
FUNCTION  MyWriteRecnoDbf2PostgreSQL( aChangeRec, AliasForRead ,cNamePgTable, cConnInfo)
// /     aChangeRec    AliasForRead
//    postgreesql
// cNamePgTable   - 
LOCAL res, ret:=.t. , nI, cMsg
LOCAL al:=Alias()
DEFAULT AliasForRead := Alias()
   //IF !empty(cNamePgTable)
   //   cNamePgTable := cStaticNamePgTable // cNamePgTable   - 
   //ENDIF
   Select(AliasForRead)
   res := PQping( cConnInfo ) //   
   IF res == PQPING_OK 
     PQexec( oServer:pDB, "BEGIN" ) //  oServer:StartTransaction()
     FOR nI := 1 TO LEN(aChangeRec)
       GOTO(aChangeRec[nI])
       ret:=MyPGWriteRecno(cNamePgTable, Dbstruct(), cConnInfo)
       IF !ret  //   
          EXIT
       ENDIF
     NEXT
     PQexec( oServer:pDB, "END" )
   ELSE
    ret:=.f.
    cMsg := " : " + GetPingResult( res ) + CRLF + "   XID="+FIELD->XID+"  "
    ? cMsg
    MsgStop(cMsg)             
   ENDIF
   Select(al)
   RETURN ret

////////////////////////////////////////////////////////////////////////////////
///     dbf   aStruct
//  cNamePgTable
//         - lFlagCheckServer 
FUNCTION MyPGWriteRecno(cNamePgTable, aStruct, lFlagCheckServer, cConnInfo)
   LOCAL res, ret:=.t., cMsg
   DEFAULT lFlagCheckServer := .f.
   DEFAULT aStruct := Dbstruct()
   //DEFAULT cNamePgTable := cStaticNamePgTable
   //   
   IF lFlagCheckServer
     res := PQping( cConnInfo ) //   
     IF  res == PQPING_OK 
       res:=.t.
     ELSE
       ret:=.f.
      cMsg := " : " + GetPingResult( res ) + CRLF + "   XID="+FIELD->XID+"  "
       ? cMsg
      MsgStop(cMsg)
       res:=.f.
     ENDIF 
   ELSE
     res:=.t.
   ENDIF

   IF res 
     //   
     Psql_query_namefields_insert( cNamePgTable, aStruct )
     Psql_query_data_insert( cNamePgTable, aStruct )
     Psql_Add_query_replace( cNamePgTable, aStruct )
     Psql_exec_insert()
     IF oQuery:NETERR()
      ? "  : ", HB_UTF8TOSTR(oQuery:ErrorMsg())  ; ? CRLF  
      ret := .f.
     ENDIF
     oQuery:Destroy()
   ENDIF
   RETURN ret    

/////////////////////////////////////////////////////////////////////
FUNCTION ReplaceDataToPg( cFld, cdata)
   //cQuery := "UPDATE " + LOWER( cStaticNamePgTable ) + " set "
   cQuery += LOWER( ALLTRIM( cFld ) ) + "=" + OUQ( cdata ) 
   cQuery += " WHERE id=" + HB_NtoS( oQuery:FIELDGET( 'id' ) )
   ? "   ", HB_UTF8TOSTR(cQuery) ; ? CRLF   
   PQexec( oServer:pDB, "BEGIN" ) //  oServer:StartTransaction()
   Psql_exec_insert()
   IF oQuery:NETERR()
      ? "     " +cFld + "  : ", cdata  ; ? CRLF  
   ENDIF
   PQexec( oServer:pDB, "END" )
   oQuery:Destroy()
   RETURN .t.

/////////////////////////////////////////////////////////////////////
// Create PG table from dbf structure
// Name_table is a name of new table in postgresql
// aStruct is DbStruct() from dbf file
FUNCTION Create_table_from_Dbf_to_Postgresql( Name_table, aStruct )
   LOCAL i, cMsg, cType, flag_primery_key := .f.
   ? "   dbf: "
   ?v aStruct 

   cQuery := 'CREATE TABLE ' + Name_table + '('
   cQuery += '    ID serial '

   FOR i := 1 TO LEN( aStruct )
      cQuery += ','
      IF astruct[ i, 1 ] == "ID"
         cMsg := ",  ID  dbf-    ID2 !;;"
         cMsg += REPLICATE( "-._.", 22 ) + ";;"
         cMsg += "Attention, the ID field of dbf-file will be renamed ID2!"
         cMsg := AtRepl( ";", cMsg, CRLF )
         Msginfo( cMsg )
         cQuery += '    ID2 '
      ELSE
         cQuery += '    ' + astruct[ i, 1 ] + ' '
      ENDIF
      cType := astruct[ i, 2 ]
      DO CASE
//    case astruct[i,2] = 'N'.and.astruct[i,4]==0
//        cQuery += 'Integer'
      CASE cType = 'N'
         cQuery += 'Numeric(' + ALLTRIM( STR( astruct[ i, 3 ], 15 ) ) + ',' + ALLTRIM( STR( astruct[ i, 4 ], 25 ) ) + ')'
      CASE cType = 'C'
         cQuery += 'Varchar(' + ALLTRIM( STR( astruct[ i, 3 ], 15 ) ) + ')'
      CASE cType = 'D'
         cQuery += 'Date'
      CASE cType = 'L'
         cQuery += 'Boolean'
      CASE cType = 'M'
         cQuery += 'Text'
      CASE cType = '@' // MODTIME
         cQuery += 'timestamp'
      CASE cType = '=' // TIMESTAMP
         cQuery += 'timestamp'
      CASE cType = '+'
         cQuery += 'Integer'
      CASE cType = '^' // ROWVER
         cQuery += 'Integer'
      OTHERWISE
         ? "  = ", cType 
         msginfo( "  = ", cType )
      ENDCASE
      IF i == LEN( astruct )
         cQuery += ' )'
      ENDIF
   NEXT
   ? CRLF ; ? "   :", cQuery  ;  ? CRLF  

   oQuery := oServer:Query( cQuery )

   IF oQuery:NETERR()
      ? "  : ", oQuery:ErrorMsg()  ; ? CRLF  
   ENDIF
   oQuery:Destroy()

   RETURN ! oQuery:NETERR()

///////////////////////////////////////////////////////////////////////
//     dbf  postgresql / Copy recordings from dbf to postgresql
FUNCTION Copy_table_from_Dbf_to_Postgresql( cNamePgTable, aStruct, cAlias )
   LOCAL nTime, cMsg, nRecno, nI := 0, lFlag := .t.

   //     
   WaitThreadCreate( 'Copy recordings from dbf to PostgreSql' )

   nTime := SECONDS()

   SELECT( cAlias )
   nRecno := LASTREC()
   ? "   :", nRecno 

   DBGOTOP()

   PQexec( oServer:pDB, "BEGIN" ) //  oServer:StartTransaction()
   //    
   Psql_query_namefields_insert( cNamePgTable, aStruct )
   WHILE ! EOF()
      cMsg := HB_NtoS( nI + 1 ) + "/" + HB_NtoS( nRecno )
      WaitThreadSay( cMsg )   //  .
      IF nI % 500 == 0  //  500 
         DO EVENTS  //    
      ENDIF
      //   
      Psql_query_data_insert( cNamePgTable, aStruct )
      DBSKIP()
      IF ! EOF()
         cQuery += ","
      ENDIF
      nI ++
   ENDDO

   Psql_exec_insert()
   WaitThreadClose()   //   ""

   PQexec( oServer:pDB, "END" )
   IF lFlag
      cMsg := "In the " + HB_NtoS( nRecno ) + " accounts took up time "
      cMsg += SECTOTIME( SECONDS() - nTime )
      //MsgInfo( cMsg )
      ? cMsg 
   ENDIF

   RETURN lFlag

////////////////////////////////////////////////////////////
//     
FUNCTION Psql_query_namefields_insert( cNamePgTable, aStruct )
   LOCAL i, j
   //   
   cQuery := "INSERT INTO " + LOWER( cNamePgTable ) + "("
   j := 0
   //   
   FOR i := 1 TO LEN( astruct )
      j ++
      IF ! j = 1
         cQuery += ","
      ENDIF
      IF astruct[ i, 1 ] == "ID"
         cQuery += 'id2'
      ELSE
         cQuery += LOWER( ALLTRIM( astruct[ i, 1 ] ) )
      ENDIF
   NEXT
   j := 0

   cQuery += ") VALUES "
   RETURN cQuery
////////////////////////////////////////////////////////////
//       dbf
FUNCTION Psql_query_data_insert( cNamePgTable, aStruct )
   LOCAL i, j, cStr := "("
   DEFAULT cNamePgTable := '???', aStruct := {}

   j := 0
   FOR i := 1 TO LEN( aStruct )
      j ++
      IF ! j = 1
         cStr += ","
      ENDIF
      cStr += ouq( FIELDGET( i ) )
   NEXT
   cQuery += cStr + ")" + CHR(13) + CHR(10)

   RETURN Nil

////////////////////////////////////////////////////////////
FUNCTION Psql_exec_insert()
   LOCAL ret := .t.
   LOCAL res, nResultStatus
   //        
   //   ? "   ", cQuery )
   res := PQexec( oServer:pDB, cQuery )
   nResultStatus := PQresultStatus( res )

   IF nResultStatus == PGRES_TUPLES_OK.OR.nResultStatus == PGRES_COMMAND_OK
      oServer:lError := .F.
      oServer:cError := ""
   ELSE
      oServer:lError := .T.
      oServer:cError := PQresultErrorMessage( res )
      ? "  : ", HB_UTF8TOSTR( oServer:ErrorMsg() ) 
      ? ",  : ", HB_UTF8TOSTR( cQuery ) 
      Msginfo( "  :" + HB_UTF8TOSTR( oServer:ErrorMsg() ) )
      ret := .f.
   ENDIF
   res := NIL
   RETURN ret

////////////////////////////////////////////////////////////
   FUNCTION Psql_Add_query_replace( cNamePgTable, aStruct )
   LOCAL i, cFld 

   cQuery += "ON CONFLICT (XID) DO NOTHING; UPDATE " + LOWER( cNamePgTable ) + " set "
   FOR i := 1 TO LEN( astruct )
   cFld := aStruct[ i, 1 ]
      IF ! ouq( &( "Field->" + ALLTRIM( cFld ) ) ) == "''"
         IF ! i = 1
            cQuery += ","
         ENDIF
         cQuery += LOWER( ALLTRIM( cFld ) ) + "=" + OUQ( &( "Field->" + ALLTRIM( cFld ) ) )
      ENDIF
   NEXT
   cQuery += " WHERE xid=" + HB_NtoS( FIELD->XID )

   RETURN cQuery 

////////////////////////////////////////////////////////////
FUNCTION Psql_replace( cQuery )
   LOCAL oQuery, ret := .t.

   oServer:StartTransaction()
   oQuery := oServer:Query( cQuery )
   IF oQuery:NETERR()
      ret := .f.
      BREAK
   ENDIF
   oQuery:destroy()
   oServer:Commit()

   RETURN ret

////////////////////////////////////////////////////////////
FUNCTION GetPingResult( n ) 
   LOCAL nLang := 2
   LOCAL aMsg := {                                                                ; 
               { "PQPING_OK", "(server is accepting connections)", "(  )"                      }, ; 
               { "PQPING_REJECT", "(server is alive but rejecting connections)","( ,   )"   }, ; 
               { "PQPING_NO_RESPONSE", "(could not establish connection)","(   )"           }, ;  
               { "PQPING_NO_ATTEMPT", "(connection not attempted (bad params))","(   ( Params))"}  ;  
                  } 

   IF hb_SetCodepage() == "RU1251"
      nLang := 3
   ENDIF

   IF n >= 0 .AND. n < Len( aMsg ) 
      RETURN ( aMsg[ n + 1 ][ 1 ] + " " + aMsg[ n + 1 ][ nLang ] ) 
   ENDIF 
    
   RETURN "" 

////////////////////////////////////////////////////////////
FUNCTION GetResultStatus( n, nRetDim ) 
   LOCAL nI, aMsg := {} 
   DEFAULT nRetDim := 2

   AADD( aMsg, { 0, "PGRES_EMPTY_QUERY" , "empty query string was executed" , "    " } )
   AADD( aMsg, { 1, "PGRES_COMMAND_OK"  , "a query command that doesn't return * anything was executed properly by the * backend *" , " ,    " } )
   AADD( aMsg, { 2, "PGRES_TUPLES_OK"   , "a query command that returns tuples was" , " ,   " } )
   AADD( aMsg, { 3, "PGRES_COPY_OUT"    , "Copy Out data transfer in progress", ",   " } )
   AADD( aMsg, { 4, "PGRES_COPY_IN"     , "Copy In data transfer in progress" , "     " } )
   AADD( aMsg, { 5, "PGRES_BAD_RESPONSE", "an unexpected response was recv'd from the backend", "      " } )
   AADD( aMsg, { 6, "PGRES_NONFATAL_ERROR", "notice or warning message", "   " } )
   AADD( aMsg, { 7, "PGRES_FATAL_ERROR" , "query failed" , " " } )
   AADD( aMsg, { 8, "PGRES_COPY_BOTH"   , "Copy In/Out data transfer in progress", "    / " } )
   AADD( aMsg, { 9, "PGRES_SINGLE_TUPLE", "single tuple from larger resultset", "     "  } )

   IF hb_SetCodepage() == "RU1251"
      IF nRetDim == 3
         nRetDim := 4
      ENDIF
   ENDIF

   IF n >= 0 .AND. n < Len( aMsg ) 
      FOR nI := 1 TO LEN( aMsg )
        IF n == aMsg[nI,1]
           RETURN ( aMsg[nI,nRetDim] ) 
        ENDIF
      NEXT
   ENDIF 
    
   RETURN "" 

////////////////////////////////////////////////////////////
FUNCTION ouq( s )
   LOCAL ret := "", t := VALTYPE( s ), r

   DO CASE
   CASE t = "C"
      s := ALLTRIM( atrepl( "'", s, '"' ) )
      ret += "'" + hb_strtoUTF8( RTRIM( s ) ) + "'"
   CASE t = "M"
      s := ALLTRIM( atrepl( "'", s, '"' ) )
      ret += "'" + hb_strtoUTF8( RTRIM( s ) ) + "'"
   CASE t = "D"
      IF EMPTY( s )
         ret := "NULL"
      ELSE
         r := DTOS( s )
         ret += "'" + SUBSTR( r, 1, 4 ) + "-" + SUBSTR( r, 5, 2 ) + "-" + SUBSTR( r, 7, 2 ) + "'"
      ENDIF
   CASE t = "N"
      ret += ALLTRIM( STR( s ) )
   CASE t = "L"
      ret += IF( s, "'t'", "'f'" )
   CASE t = 'T'
      IF ! EMPTY( s )
         ret += "'" + SUBSTR( HB_TSTOSTR( s ), 1, 19 ) + "'"
      ELSE
         ret += "NULL"
      ENDIF
   OTHERWISE
      ? "  ", t 
      ret += "NULL"
   ENDCASE
   ret := CHARREM( CHR(0),ret)
   RETURN ret + ""

////////////////////////////////////////////////////////////
FUNCTION inq( s )
   LOCAL ret := "", t := VALTYPE( s )

   DO CASE
   CASE t = "C"
      ret := RTRIM( HB_UTF8TOSTR( s ) )
   CASE t = "D"
   //     r:=dtos(s)
   //     ret+=stod(substr(r,7,4)+substr(r,1,2)+substr(r,3,2))
      ret := s
   CASE t = "N"
   //     ret+=val(s)
      ret := s
   CASE t = "L"
   //     ret:=if(s="t",.t.,.f.)
      ret := s
   OTHERWISE
      ret := ""
   ENDCASE

   RETURN ret

///////////////////////////////////////////////////////////////////
FUNCTION FORM_SQLINDEX
    MsgDebug("???????????")
RETURN NIL

////////////////////////////////////////////////////////////////////////////////
FUNCTION MyPgQuery(cQuery,cConnInfo,nFlag)
   LOCAL res, cMsg, aTblStruct, aRet, nResultStatus, lRet := .F.
   DEFAULT nFlag := 1, cConnInfo := M->cPubPgConnInfo

   res := PQping( cConnInfo ) //   
   IF res == PQPING_OK 
      res := PQexec( oServer:pDB, cQuery )
      cMsg := "  : " + cQuery + CRLF
      nResultStatus := PQresultStatus( res )
      IF nResultStatus == PGRES_COMMAND_OK
         cMsg +=  ": " + GetResultStatus( nResultStatus, 2 ) + CRLF
         IF nFlag > 0 ; MsgInfo( cMsg )
         ENDIF 
         lRet := .T.
      ELSE
         cMsg +=  ": " + GetResultStatus( nResultStatus, 2 ) + " - " 
         cMsg +=  GetResultStatus( nResultStatus, 3 ) + CRLF
         IF nFlag > 0 ; MsgStop( cMsg ) 
         ENDIF 
      ENDIF
      ? cMsg  
   ELSE
      cMsg := " : " + GetPingResult( res ) + CRLF 
      ? cMsg
      MsgStop(cMsg)
   ENDIF 

   RETURN lRet

